var createError = require('http-errors');
var express = require('express');
var cors = require('cors');
var path = require('path');
var cookieParser = require('cookie-parser');
var logger = require('morgan');

//var indexRouter = require('./routes/index');
//var wmsRouter = require('./routes/wms');
//var usersRouter = require('./routes/users');
//var emsRouter = require('./routes/ems');
//var secureRouter = require('./routes/secure');
//var eshopadminRouter = require('./routes/eshopadmin');
//var mobileRouter = require('./routes/mobile');
var indexRouter_indore 	= require('./routes/indexindore');
var inventoryRouter 	= require('./routes/inventory');
//var socketapi_jhansi = require('./routes/socketapi');

var app = express();

// view engine setup
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'jade');

app.use(cors())
app.use(logger('dev'));
app.use(express.json());
app.use(express.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, 'public')));

// custom code

app.use(function(req, res, next) {
  res.header("Access-Control-Allow-Origin", "*");
  res.header("Access-Control-Allow-Headers", "Origin, X-Requested-With, Content-Type, Accept");
  next();
});

// end custom code

//app.use('/', indexRouter);
app.use('/indoreapi', indexRouter_indore);
app.use('/inventoryapi', inventoryRouter);
//app.use('/jhansisocketapi', socketapi_jhansi);
//app.use('/users', usersRouter);
//app.use('/wms-api', wmsRouter);
//app.use('/ems', emsRouter);
//app.use('/secure-api', secureRouter);
//app.use('/eshopadmin-api', eshopadminRouter);
//app.use('/mobile-api', mobileRouter);

// catch 404 and forward to error handler
app.use(function(req, res, next) {
  next(createError(404));
});

// error handler
app.use(function(err, req, res, next) {
  // set locals, only providing error in development
  res.locals.message = err.message;
  res.locals.error = req.app.get('env') === 'development' ? err : {};

  // render the error page
  res.status(err.status || 500);
  res.render('error');
});

module.exports = app;
