const fs = require('fs')
var exec = require('child_process').exec;
//var child = exec(' C:/xampp/mysql/bin/mysqldump -u root --no-tablespaces wdms daily_consumption --where="id >= 1 AND id<10" > DUMP_MH_415_2K.sql '); 

var mysql = require('mysql');
var moment = require("moment");

var schedule = require('node-schedule');
var dateFormat = require('dateformat');

var connection = mysql.createConnection({
	multipleStatements: true,
	host     : 'localhost',
	user     : 'ccmsup_usr',
	password : 'az7gurl0nmns',
	database : 'ccmsup_db',
	dateStrings: [
		'DATE',
		'DATETIME'
	  ]
});

var time_interval = '';
var min_id = 0;
var max_id = 0;
var last_id = 0;

setTimeout(initprocess, 1000);
function initprocess(){
	console.log("Start backup process");
	var sql = "SELECT MIN(id) min_id, MAX(id) max_id FROM device_received_data_clone;";

	connection.query(sql, function selectCb(err, results, fields) {
		if (err) console.log(err);
		else {
			if(results.length > 0){
				min_id = results[0].min_id;
				max_id = results[0].max_id;
				
				backupprocess();
				
				//setTimeout(backupprocess, TENMIN);
			}else{
				console.log("NO RECORDS");
			}
		}
	});
}

function backupprocess(){
	last_id = min_id + 5000000;
	var name = parseInt(last_id/1000000);
				
	console.log(`Backup records from ID >= ${min_id} AND ID < ${last_id} .`);
	
	var start_time = moment().format("YYYY-MM-DD HH:mm:ss");
	var end_time = moment().format("YYYY-MM-DD HH:mm:ss");
	
	wait_call('Waiting');
	
	var backupfile = '../../../backup/DUMP_UP_'+name+'_2K.sql';
	
	
	exec(' mysqldump -u ccmsup_usr -paz7gurl0nmns --no-tablespaces ccmsup_db device_received_data_clone --where="id >= '+min_id+' AND id < '+last_id+' " > '+backupfile, (error, stdout, stderr) => {
		if (error) {
			console.error(`exec error: ${error}`);
			return;
		}
		end_time = moment().format("YYYY-MM-DD HH:mm:ss");
		
		var diff = moment(end_time).diff(start_time, 'seconds');
		
		console.log(`stdout: ${stdout}`);
		console.error(`stderr: ${stderr}`);
		
		clearInterval(time_interval);
		
		console.log("Process completed in "+diff+" seconds");
		console.log("SQL file generated : DUMP_UP_"+name+"_2K.sql");
		
		if(last_id + 15000000 < max_id){
			
			try {
				if (fs.existsSync(backupfile)) {
					console.log("DUMP_UP_"+name+"_2K.sql [OK]");
					
					console.log("Start transfering data in backup table!");
					var sql = 'INSERT INTO device_received_data_backup SELECT * FROM device_received_data_clone WHERE id >= '+min_id+' AND id < '+last_id;
					
					wait_call('Coping');
					//DELETE FROM device_received_data_clone WHERE id < 425000000;

					connection.query(sql, function selectCb(err, results, fields) {
						if (err) console.log(err);
						else {
							console.log("Data stored in backup table!");
							
							min_id = last_id;
							
							wait_call('Sleeping');
							
							console.log('Next process is starting in 5 min.');
							setTimeout(backupprocess, 300 * 1000);
							
							if(results.length > 0){
								//DELETE FROM `device_received_data_clone` WHERE id < 455000000
								
							}
						}
					})
				}
			} catch(err) {
				console.log("DUMP_UP_"+name+"_2K.sql [INVALID]");
				//console.error(err)
			}
			
			
		}
		console.log();
	});
}

function verifyingfiles(fname){
	const fs = require('fs')

	try {
		if (fs.existsSync('../../../'+fname)) {
			console.log(fname+ ' [OK]');
		}
	} catch(err) {
		console.log(fname+ ' [INVALID]');
		//console.error(err)
	}
}

function wait_call(msg = 'Waiting'){
	var i = 0;  // dots counter
	var secs = 0;
	
	var TimeS = moment().format("YYYY-MM-DD HH:mm:ss");
	var TimeE = moment().format("YYYY-MM-DD HH:mm:ss");
	
	clearInterval(time_interval);
	time_interval = setInterval(function() {
		process.stdout.clearLine();  // clear current text
		process.stdout.cursorTo(0);  // move cursor to beginning of line
		i = (i + 1) % 6;
		var dots = new Array(i + 1).join(".");

		secs = moment(TimeE).diff(TimeS, 'seconds');
		TimeE = moment().format("YYYY-MM-DD HH:mm:ss");

		process.stdout.write(msg+" ["+secs+" seconds]" + dots);  // write text
	}, 200);
}
//mysqldump -u i3wd_slc -p --no-tablespaces i3wd_slc device_received_data_clone --where="id >= 410000000 AND id<415000000" > DUMP_MH_415_2K.sql;