var net = require('net');
var mysql = require('mysql');
var moment = require("moment");
var empty = require('is-empty');
var dateFormat = require('dateformat');

var HOST = '103.211.218.36';
var PORT = 33344;

var connection = mysql.createConnection({
	multipleStatements: true,
	host     : 'localhost',
	user     : 'ccms_usr',
	password : 'ah8vx61mxrbv',
	database : 'ccms_ems',
	dateStrings: [
		'DATE',
		'DATETIME'
	  ]
});

var interval = '';

var fx = 0;
var lx = 6;

var server = net.createServer(function(sock) {
    console.log('SERVER: ' + sock.remoteAddress +':'+ sock.remotePort);
	
    sock.on('data', function(data) 
	{
		if(data.length < 10){
			console.log('--- NO DATA ---');
			return;
		}
		var dt = new Date();
		var buff = Buffer.from(data, 'utf8');
		var hexdata = buff.toString('hex');
		console.log('ORIGINAL: ' + hexdata);
		
		var regExp = /(?<=5b)(.*)(?=5d)/;
        var matches = hexdata.match(regExp) 

        var d = matches[1];


		
		console.log(">>>   "+d);
		
		if(d != ""){
		    var STATUS = "";
			var TYPE = "";
			var ACTUAL_DATA = d;
			var ACTUALDATALENGTH = d.length;

			var fx = 0; 
			var lx = 0;
			
			fx += lx; lx = 6;
			var DS_DATE = d.substr(fx, lx);
			var DS_DD = Pad(parseInt(DS_DATE.substr(0, 2), 16), 2);
			var DS_MM = Pad(parseInt(DS_DATE.substr(2, 2), 16), 2);
			var DS_YY = Pad(parseInt(DS_DATE.substr(4, 2), 16), 2);
			
			fx += lx; lx = 6;
			var DS_TIME = d.substr(fx, lx);
			var DS_HH = Pad(parseInt(DS_TIME.substr(0, 2), 16), 2);
			var DS_MI = Pad(parseInt(DS_TIME.substr(2, 2), 16), 2);
			var DS_SS = Pad(parseInt(DS_TIME.substr(4, 2), 16), 2);
			var DATA_STAMP = DS_YY+"-"+DS_MM+"-"+DS_DD+" "+DS_HH+":"+DS_MI+":"+DS_SS;
			
			var RTC_TIME = DS_HH+"."+DS_MI;
			
			
			fx += lx; lx = 30;
			IMEI_NO = '';
			for(var i = fx; i<fx+lx; i+=2){
				IMEI_NO += String.fromCharCode(parseInt(d.substr(i,2), 16));
			}				
			if(IMEI_NO == '000000000000000'){
				console.log('WRONG IMEI NO');
				return false;
			}

			writeLog(IMEI_NO, d);
			
			
			fx += lx; lx = 2;
			var SL_VOLTAGE = parseInt(d.substr(fx, lx), 16);
			fx += lx; lx = 2;
			var v1 = d.substr(fx,lx);
			fx += lx; lx = 2;
			var v2 = d.substr(fx,lx);
			var BT_VOLTAGE = HexToDec(String(v2)+String(v1));
			
			fx += lx; lx = 26;
			var DIGITAL_OUTPUT = '';
			for(var i = fx; i<fx+lx; i+=2){
				DIGITAL_OUTPUT += String(parseInt(d.substr(i,2), 16));
			}
			
			var OUTPUT_STATUS = DIGITAL_OUTPUT.substr(6, 1);
			
			var ACTUAL_DATA = d;
			var ACTUALDATALENGTH = d.length;
			
			//fx += lx; lx = 6;
			//var DIGITAL_INPUT = d.substr(fx, lx);
			var DOOR_STATUS = DIGITAL_OUTPUT.substr(12, 1);
			
			fx += lx; lx = 6;
			var IO_DATE = d.substr(fx, lx);
			var IO_DD = Pad(parseInt(IO_DATE.substr(0, 2), 16), 2);
			var IO_MM = Pad(parseInt(IO_DATE.substr(2, 2), 16), 2);
			var IO_YY = Pad(parseInt(IO_DATE.substr(4, 2), 16), 2);
			
			fx += lx; lx = 6;
			var IO_TIME = d.substr(fx, lx);
			var IO_HH = Pad(parseInt(IO_TIME.substr(0, 2), 16), 2);
			var IO_MI = Pad(parseInt(IO_TIME.substr(2, 2), 16), 2);
			var IO_SS = Pad(parseInt(IO_TIME.substr(4, 2), 16), 2);
			var IO_STAMP = IO_YY+"-"+IO_MM+"-"+IO_DD+" "+IO_HH+":"+IO_MI+":"+IO_SS;

			if(IO_YY == 0){
				var now = new Date();
				IO_STAMP = dateFormat(now, "yyyy-mm-dd HH:MM:ss");
			}

			console.log("DATALENGTH "+ ACTUALDATALENGTH);
			console.log("DATASTAMP "+DATA_STAMP);
			console.log("IMEI_NO "+IMEI_NO);
			console.log("SUPPLY "+ SL_VOLTAGE);
			console.log("BATTERY "+ BT_VOLTAGE);
			console.log("DIGITAL_OUTPUT "+DIGITAL_OUTPUT);
			console.log("OUTPUT_STATUS "+ OUTPUT_STATUS);
			console.log("DOOR_STATUS "+ DOOR_STATUS);
			console.log("IO_STAMP "+IO_DATE+""+IO_TIME+" "+IO_STAMP);


			fx += lx; lx = 4; T1 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
			fx += lx; lx = 4; T2 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
			fx += lx; lx = 4; T3 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
			fx += lx; lx = 4; T4 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
			
			console.log("T1 "+T1+" ");
			console.log("T2 "+T2);
			console.log("T3 "+T3);
			console.log("T4 "+T4);
			return;



			fx += lx; lx = 40;
			var START = d.substr(fx, lx);

			fx += lx; lx = d.length - 40;
			var FULLDATA = d.substr(126, d.length -166);

			console.log("FULLDATA LENGTH "+FULLDATA.length);
			var MODEM_DATA_LEN = 96;
			var TOTAL_DATA = FULLDATA.length/MODEM_DATA_LEN;
			console.log("TOTAL DATA "+TOTAL_DATA);

			writeLog(IMEI_NO, d);

			return;

			var jsondata = new Array();
			for (var i = 0; i < TOTAL_DATA; i++) {
				var di = FULLDATA.substr(i*MODEM_DATA_LEN, MODEM_DATA_LEN);

				var fx = 0;
				var lx = 0;
	    		var VOLTAGE_R,VOLTAGE_Y,VOLTAGE_B,AMP_R,AMP_Y,AMP_B;

	    		

				fx += lx; lx = 8; VOLTAGE_R = getHexToDecimal(di.substr(fx, lx/2), di.substr(fx+lx/2, lx/2));
				fx += lx; lx = 8; VOLTAGE_Y = getHexToDecimal(di.substr(fx, lx/2), di.substr(fx+lx/2, lx/2));
				fx += lx; lx = 8; VOLTAGE_B = getHexToDecimal(di.substr(fx, lx/2), di.substr(fx+lx/2, lx/2));
				fx += lx; lx = 8; AMP_R = getHexToDecimal(di.substr(fx, lx/2), di.substr(fx+lx/2, lx/2));
				fx += lx; lx = 8; AMP_Y = getHexToDecimal(di.substr(fx, lx/2), di.substr(fx+lx/2, lx/2));
				fx += lx; lx = 8; AMP_B = getHexToDecimal(di.substr(fx, lx/2), di.substr(fx+lx/2, lx/2));

	    		console.log("VOLTAGE R "+VOLTAGE_R +" VOLTAGE Y "+VOLTAGE_Y+" VOLTAGE B "+VOLTAGE_B);
	    		//console.log("AMP R "+AMP_R +" AMP Y "+AMP_Y+" AMP B "+AMP_B);


	    		fx += lx; lx = 8;
				var KW = getHexToDecimal(di.substr(fx, lx/2), di.substr(fx+lx/2, lx/2));
				//MASTER_DATA[IMEI_NO]['PREV_LOAD'] = KW;

				//console.log("KW "+KW);

				fx += lx; lx = 8;
				var FREQUENCY = getHexToDecimal(di.substr(fx, lx/2), di.substr(fx+lx/2, lx/2));

				//console.log("FREQUENCY "+FREQUENCY);

				fx += lx; lx = 8;
				var PF = getHexToDecimal(di.substr(fx, lx/2), di.substr(fx+lx/2, lx/2));

				//console.log("PF "+PF);
				
				fx += lx; lx = 8;
				var KWH = getHexToDecimal(di.substr(fx, lx/2), di.substr(fx+lx/2, lx/2));

				//console.log("KWH "+KWH);

				fx += lx; lx = 8;
				var FAULT = getHexToDecimal(di.substr(fx, lx/2), di.substr(fx+lx/2, lx/2));

				//console.log("FAULT "+FAULT);

				fx += lx; lx = 8;
				var RH_HRS = getHexToDecimal(di.substr(fx, lx/2), di.substr(fx+lx/2, lx/2));

				console.log("RH_HRS "+RH_HRS);

				fx += lx; lx = 8;
				//var RH_CYCLE = getHexToDecimal(di.substr(fx, lx/2), di.substr(fx+lx/2, lx/2));
				var RH_CYCLE = 0;
				console.log("RH_CYCLE "+di.substr(fx, lx/2)+" "+di.substr(fx+lx/2, lx/2));

				var now = new Date();
				var created_at = dateFormat(now, "isoDateTime");

				var type = 'EM'+(i+1);
				

				var _jsonobj = {
					type: type,
					volt_r: VOLTAGE_R,
					volt_y: VOLTAGE_Y,
					volt_b: VOLTAGE_B,
					amp_r: AMP_R,
					amp_y: AMP_Y,
					amp_b: AMP_B,
					kw: KW,
					freq: FREQUENCY,
					pf: PF,
					kwh: KWH,
					fault: FAULT,
					rh_hrs: RH_HRS,
					rh_cycle: RH_CYCLE
				}
				if(KWH > 0){
					jsondata.push(_jsonobj);
				}
			}

			var ddinsertq = {
				imei_no: IMEI_NO,
				data_stamp: DATA_STAMP,
				supply: SL_VOLTAGE,
				battery: BT_VOLTAGE,
				inputs: DIGITAL_OUTPUT,
				outputs: DIGITAL_OUTPUT,
				io_stamp: IO_STAMP,
				datalength: ACTUALDATALENGTH
			}

			var sql = "INSERT INTO device_data SET ?, insert_time = NOW();";
				
			connection.query(sql, ddinsertq, function selectCb(err, results, fields) {
				if (err){
					console.log("ERROR DATA LENGTH "+data.length);
					console.log("ERROR IMEI_NO "+IMEI_NO);
					console.log(err);
				}else{ 
					var ddupdateq = {
						data_stamp: DATA_STAMP,
						supply: SL_VOLTAGE,
						battery: BT_VOLTAGE,
						inputs: DIGITAL_OUTPUT,
						outputs: DIGITAL_OUTPUT,
						io_stamp: IO_STAMP,
						datalength: ACTUALDATALENGTH
					}
					var sql = "UPDATE device_last_data SET ?, update_time=NOW() WHERE imei_no=?;";
					connection.query(sql, [ddupdateq, IMEI_NO], function selectCb(err, results, fields) {
						if (err) {
							console.log(err);
						}else{ 
							//console.log("INSERT TRANS LAST DATA OK");
						}
					});
				}
			});

			var insertq = {
				imei_no: IMEI_NO,
				jsondata: JSON.stringify(jsondata)
			}

			var sql = "INSERT INTO meter_data SET ?, insert_time = NOW();";
				
			connection.query(sql, insertq, function selectCb(err, results, fields) {
				if (err){
					console.log("ERROR DATA LENGTH "+data.length);
					console.log("ERROR IMEI_NO "+IMEI_NO);
					console.log(err);
				}else{ 
					var updateq = {
						jsondata: JSON.stringify(jsondata)
					}
					var sql = "UPDATE meter_last_data SET ?, update_time=NOW() WHERE imei_no=?;";
					connection.query(sql, [updateq, IMEI_NO], function selectCb(err, results, fields) {
						if (err) {
							console.log(err);
						}else{ 
							//console.log("INSERT TRANS LAST DATA OK");
						}
					});
				}
			});
		}

		writeLog(IMEI_NO, d);
		
    });
    sock.on('close', function(data) 
	{
        console.log('SOCKET CLOSING ');
    });
	sock.on('end', function() {
        console.log('SOCKET END ');
    });
	sock.on('error', function(){
		console.log('ERROR IN SOCKET CONNECTION');
	});
	sock.setKeepAlive(true);
}).on('error', function(err) {
	console.log('ERROR '+ err);
});
server.listen(PORT, HOST);

server.on('connection', function(sock)
{
	console.log('SOCKET CONNECTED....');
});
console.log('SERVER LISTENING ON ' + HOST +':'+ PORT);

function writeLog(IMEI_NO, DATA, TYPE){
	var d = new Date();
	//var time = dateFormat(d, "isoDateTime");
	
	//var file = d.getUTCFullYear()+"-"+(d.getUTCMonth() + 1)+"-"+(d.getUTCDate())+".txt";
	var file = "port-test.txt";
	
	var fs = require('fs');
	const path = require('path');
	
	fs.exists(path.normalize(__dirname+'../../../../logs/'+file), function(exist){
		if(exist){
			var str = IMEI_NO + "," + DATA;
			fs.appendFile(path.normalize(__dirname+'../../../../logs/'+file), '\r\n'+str, function(err1) {
				if (err1) console.log(err1);
			});
		}else{
			fs.writeFile(path.normalize(__dirname+'../../../../logs/'+file), '--- Start Logging ---', function(err2) {
				if (err2) console.log(err2);
				console.log('NEW LOG FILE CREATED!');
			});
		}
	});
}


function Pad (str, max) {
	str = str.toString();
	return str.length < max ? Pad("0" + str, max) : str;
}
function hexval(str){
	var arr = [];
	for(var i=0; i<str.length-1; i+=2){
		arr.push(str.substr(i, 2));
	}
	var code = arr.reverse().join().replace(/,/g,'').toString();
	return parseInt(code, 16);
}
function HexToFloat(value){
	return new Buffer(value, 'hex').readFloatBE().toFixed(2);
}
function HexToDecimal(value){
	return parseInt(Pad(value,4), 16);
}
function HexToBin(value){
	var bytes = "";
	for(var i=0; i< value.length; i++){
		bytes += Pad(parseInt(value.substr(i, 1), 16).toString(2), 4);
	}
	return bytes;
}

function getHexToDecimal2(v1,v2){
	if(v2 == '0000' && v1 == '0000'){
		return 0;
	}
	return String(HexToDecimal(String(v2)+String(v1)));//+String(HexToDecimal(v2));
}
function getHexToDecimal(v1,v2){
	if(v2 == '0000' && v1 == '0000'){
		return 0;
	}
	return String(HexToDecimal(String(v2)+String(v1)));
	//return String(HexToDecimal(String(v2)+String(v1)));//+String(HexToDecimal(v2));
	//return String(HexToFloat(String(v2)+String(v1)));
}

function HexToDec(value){
	return parseInt(value, 16);
}



/*
030e0a0c0636383630393336303534373832343831785e01000100000000ffffffffffffffffffffffffff
0000000000000000000000000000000000000000
00004370199a437100004372000041200000413000004140e400464000000000cccd3f4c000043e40000400000010002
00004370199a437100004372000041200000413000004140e400464000000000cccd3f4c000043e40000400000010002
00004370199a437100004372000041200000413000004140e400464000000000cccd3f4c000043e40000400000010002
00004370199a437100004372000041200000413000004140e400464000000000cccd3f4c000043e40000400000010002
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000
*/

/*
var net = require('net');
var moment = require("moment");
var empty = require('is-empty');

var HOST = '103.211.218.36';
var PORT = 33344;

var interval = '';

var fx = 0;
var lx = 6;

var server = net.createServer(function(sock) {
    console.log('SERVER: ' + sock.remoteAddress +':'+ sock.remotePort);
	
    sock.on('data', function(data) 
	{
		var dt = new Date();
		var buff = Buffer.from(data, 'utf8');
		var d = buff.toString('hex');
		console.log('ORIGINAL: ' + d);
		
		writeLog('009900', d);
		
    });
    sock.on('close', function(data) 
	{
        console.log('SOCKET CLOSING ');
    });
	sock.on('end', function() {
        console.log('SOCKET END ');
    });
	sock.on('error', function(){
		console.log('ERROR IN SOCKET CONNECTION');
	});
	sock.setKeepAlive(true);
}).on('error', function(err) {
	console.log('ERROR '+ err);
});
server.listen(PORT, HOST);

server.on('connection', function(sock)
{
	console.log('SOCKET CONNECTED....');
});
console.log('SERVER LISTENING ON ' + HOST +':'+ PORT);

function writeLog(IMEI_NO, DATA, TYPE){
	var d = new Date();
	//var time = dateFormat(d, "isoDateTime");
	
	//var file = d.getUTCFullYear()+"-"+(d.getUTCMonth() + 1)+"-"+(d.getUTCDate())+".txt";
	var file = "port-test.txt";
	
	var fs = require('fs');
	fs.exists('logs/'+file, function(exist){
		if(exist){
			var str = IMEI_NO + "," + DATA;
			fs.appendFile('logs/'+file, '\r\n'+str, function(err1) {
				if (err1) console.log(err1);
			});
		}else{
			fs.writeFile('logs/'+file, '--- Start Logging ---', function(err2) {
				if (err2) console.log(err2);
				console.log('NEW LOG FILE CREATED!');
			});
		}
	});
}
*/