var net = require('net');
var mysql = require('mysql');
var moment = require("moment");
var httpserver = require('http').createServer();
var socketio = require('socket.io')(httpserver);
var empty = require('is-empty');

var schedule = require('node-schedule');

var HOST = '216.10.251.190';
var PORT = 33333;
var HTTP_PORT = 33334;

var connection = mysql.createConnection({
	multipleStatements: true,
	host     : 'localhost',
	user     : 'i3wd_slc',
	password : 'xmwmce4celwi',
	database : 'i3wd_slc',
	dateStrings: [
		'DATE',
		'DATETIME'
	]
});

var dateFormat = require('dateformat');
var interval = '';
var sockets = [];
var sockets_info = [];

var METER_SINGLE_PHASE = 1;
var METER_THREE_PHASE = 3;

var httpsockets = new Array();

var dt = new Date();
var master_data_time = dt.getTime();


socketio.on('connection', function (httpsocket){
    var nb = 0;

    console.log('SocketIO > Connected socket ' + httpsocket.id);

    httpsockets.push(httpsocket);

    httpsocket.on('getdata', data => {
    	console.log('--------- WEB PAGE REQUEST --------- '+data);
    	
    	var devices = new Array();
    	for (const [key, value] of Object.entries(MASTER_DATA)) {
			if(areacode == value.ULB_CODE){
				devices.push(value);
			}
		}
		var result = new Object();
		result.time = moment().format("YYYY-MM-DD HH:mm:ss");
		result.devices = devices;
		httpsocket.emit('datarecieved', result);
    });

    httpsocket.on('disconnect', function () {
    	var i = 0;
    	httpsockets.forEach(sock => {
    		i++;
		  	if(httpsocket.id == sock.id){
		  		httpsockets.splice(i, 1);
		  		break;
		  	}
		});
        console.log('SocketIO : Received ' + nb + ' messages');
        console.log('SocketIO > Disconnected socket ' + httpsocket.id);
    });
});
console.log("Listening PORT ");
httpserver.listen(HTTP_PORT);





var server = net.createServer(function(sock) {
    console.log('SERVER: ' + sock.remoteAddress +':'+ sock.remotePort);
	
    
    sock.on('data', function(data) 
	{
		//var dt = new Date();
		var save_kwh = false;

		console.log("DATA "+data);
		writeLog('NEW', data);
		
		ST = dt.getTime();
		
		var d = data.toString().replace("CC91DD","");

		var devicetype = data.toString().indexOf("53504D");

		var METER_PHASE_TYPE = 0;
		if(devicetype > 0){
			METER_PHASE_TYPE = METER_SINGLE_PHASE;
		}else{
			METER_PHASE_TYPE = METER_THREE_PHASE;
		}




		fx = 0; lx = 6;
		var datestr = d.substr(fx, lx);
		var dd = datestr.substr(0, 2);
		var mm = datestr.substr(2, 2);
		var yy = datestr.substr(4, 2);
		var rec_date = yy+"-"+mm+"-"+dd;
		
		fx += lx; lx = 6;
		var timestr = d.substr(fx, lx);
		var hh = timestr.substr(0, 2);
		var mmj = timestr.substr(2, 2);
		var ss = timestr.substr(4, 2);
		var rec_time = hh+":"+mmj+":"+ss;

		var skip = false;
		dt = new Date();
		if((dt.getTime() - master_data_time) < 10000 && (dt.getTime() - master_data_time) > -10000){
			skip = true;
		}
		if(!skip){
			var date_rtc = moment("20"+rec_date+" "+rec_time);
			var date_curr = moment().format("YYYY-MM-DD HH:mm");
			console.log("TIME DFFEERCE "+moment(date_curr).diff(date_rtc,'minutes')+" "+date_rtc+" "+date_curr);
			if(moment(date_curr).diff(date_rtc,'minutes') >= 0 && moment(date_curr).diff(date_rtc,'minutes') < 2){
				console.log('OK DATA');
			}else{
				
				
				var now = new Date();
				var newdate = dateFormat(now, "ddmmyyHHMMss");
				sock.write("RTC,"+newdate);

				console.log('WRITING SOCKET '+newdate);

				//MASTER_DATA[IMEI_NO]['RTC_SET_TIME'] = moment().format("DD-MM-YYYY HH:mm:ss");
			}
		}

		
		fx += lx; lx = 15;
		var IMEI_NO = d.substr(fx, lx);

		var insertq = {
			imei_no: IMEI_NO,
			datastring: data,
		}
		var sql = 'INSERT INTO ccms_testing SET ?, insert_time=NOW();';
		connection.query(sql, [insertq], function selectCb(err, results, fields) {
			if (err) {
				console.log(err);
			}else{ 
				console.log("INSERT OK");
			}
		});

		

		console.log('METER PHASE TYPE : '+METER_PHASE_TYPE);
		console.log('IMEI NO : '+IMEI_NO);
		console.log('DATETIME : '+rec_date+' '+rec_time);
		console.log('DATALENGTH : '+data.length);
    });
    sock.on('close', function(data) 
	{
        console.log('SOCKET CLOSING ');
		var idx = sockets.indexOf(this);
		if (idx != -1) 
		{
			sockets.splice(idx,1);
		}
		//console.log('TOTAL NUMBER OF CONNECTIONS: '+sockets.length);
    });
	sock.on('end', function() {
        console.log('SOCKET END ');
		var idx = sockets.indexOf(this);
		if (idx != -1) {
			sockets.splice(idx,1);
		}
		//console.log('TOTAL NUMBER OF CONNECTIONS: '+sockets.length);
    });
	sock.on('error', function(){
		console.log('ERROR IN SOCKET CONNECTION');
		var idx = sockets.indexOf(this);
		if (idx != -1) {
			sockets.splice(idx,1);
		}
		//console.log('TOTAL NUMBER OF CONNECTIONS: '+sockets.length);
	});
	sock.setKeepAlive(true);
}).on('error', function(err) {
	console.log('ERROR '+ err);
});
server.listen(PORT, HOST);
function writeLog(IMEI_NO, DATA, TYPE){
	var d = new Date();
	var time = dateFormat(d, "isoDateTime");
	
	var file = PORT+"-"+d.getUTCFullYear()+"-"+(d.getUTCMonth() + 1)+"-"+(d.getUTCDate())+".txt";
	if(TYPE == "SCHEDULE"){
		file = "schedule_log.txt";
	}
	
	var fs = require('fs');
	const path = require('path');
	fs.exists(path.normalize(__dirname+'../../../../logs/'+file), function(exist){
		if(exist){
			var str = time + "," + IMEI_NO + "," + DATA;
			fs.appendFile(path.normalize(__dirname+'../../../../logs/'+file), '\r\n'+str, function(err1) {
				if (err1) console.log(err1);
			});
		}else{
			fs.writeFile(path.normalize(__dirname+'../../../../logs/'+file), '--- Start Logging ---', function(err2) {
				if (err2) console.log(err2);
				console.log('NEW LOG FILE CREATED!');
			});
		}
	});
}
server.on('connection', function(sock)
{
	//console.log('SOCKET CONNECTION: ' + sock.remoteAddress +':'+ sock.remotePort);
	sockets.push(sock);
	
	var now = new Date();
	var newdate = dateFormat(now, "ddmmyyHHMMss");
	sock.write("RTC,"+newdate);
		
	//console.log('TOTAL NUMBER OF CONNECTIONS: '+sockets.length);
});
console.log('SERVER LISTENING ON ' + HOST +':'+ PORT);

function Pad (str, max) {
	str = str.toString();
	return str.length < max ? Pad("0" + str, max) : str;
}
function hexval(str){
	var arr = [];
	for(var i=0; i<str.length-1; i+=2){
		arr.push(str.substr(i, 2));
	}
	var code = arr.reverse().join().replace(/,/g,'').toString();
	return parseInt(code, 16);
}


function in_schedule(curr_time,start_time,end_time){
	if(start_time != '' && end_time!= '' && start_time != null && end_time!= null){
		var cal_start_time = parseFloat(start_time.split(":")[0]+'.'+start_time.split(":")[1]);
		var cal_end_time = parseFloat(end_time.split(":")[0]+'.'+end_time.split(":")[1]);
		var cal_curr_time = moment(curr_time).format("HH.mm");

		var start_date = '';
		var end_date = '';
		if(cal_start_time > cal_end_time){
			if(cal_curr_time <= 24.00 && cal_curr_time > cal_start_time){
				start_date = moment(curr_time).format("YYYY-MM-DD")+" "+start_time;
				end_date = moment(curr_time).add(1, 'day').format("YYYY-MM-DD")+" "+end_time;
			}else if(cal_curr_time < cal_end_time){
				//console.log("ELSE IF");
				start_date = moment(curr_time).subtract(1, 'day').format("YYYY-MM-DD")+" "+start_time;
				end_date = moment(curr_time).format("YYYY-MM-DD")+" "+end_time;
			}else{
				//console.log("ELSE ");
				start_date = moment(curr_time).format("YYYY-MM-DD")+" "+start_time;
				end_date = moment(curr_time).add(1, 'day').format("YYYY-MM-DD")+" "+end_time;
			}
		}else{
			start_date = moment(curr_time).format("YYYY-MM-DD")+" "+start_time;
			end_date = moment(curr_time).format("YYYY-MM-DD")+" "+end_time;
		}
		if(moment(curr_time).diff(start_date, 'minutes') > 0){
			return true;
		}
	}
	return false;
}
