var net = require('net');
var mysql = require('mysql');
var moment = require("moment");
var httpserver = require('http').createServer();
var socketio = require('socket.io')(httpserver);
var empty = require('is-empty');

var schedule = require('node-schedule');
const struct = require('python-struct');
var HOST = '216.10.251.190';
var PORT = 33333;
var HTTP_PORT = 32992;

var connection = mysql.createConnection({
	multipleStatements: true,
	host     : '13.200.81.42',
	user     : 'i3wd_slc',
	password : 'xmwmce4celwi',
	database : 'i3wd_slc',
	dateStrings: [
		'DATE',
		'DATETIME'
	]
});

var interval = '';
var sockets = [];
var sockets_info = [];

var METER_SINGLE_PHASE = 1;
var METER_THREE_PHASE = 3;

var httpsockets = new Array();

var dt = new Date();
var master_data_time = dt.getTime();





var server = net.createServer(function(sock) {
    console.log('SERVER: ' + sock.remoteAddress +':'+ sock.remotePort);
	
    
    sock.on('data', function(data) 
	{
		//var dt = new Date();
		var save_kwh = false;
		var buff = Buffer.from(data, 'utf8');
		var hexdata = buff.toString('hex');
		console.log(":: DATA "+hexdata);
		
		var regExp = /(?<=5b)(.*)(?=5d)/;
        var matches = hexdata.match(regExp) 
        
        var d = '';
        if(!empty(matches)){
        	if(matches.length > 0){
        		d = matches[1];
				
				var STATUS = "";
				var TYPE = "";
				var ACTUAL_DATA = d;
				var ACTUALDATALENGTH = d.length;

				//var devicetype = d.toUpperCase().indexOf("53504D");

				var fx = 0; 
				var lx = 0;
				
				fx += lx; lx = 6;
				var DS_DATE = d.substr(fx, lx);
				var DS_DD = Pad(parseInt(DS_DATE.substr(0, 2), 16), 2);
				var DS_MM = Pad(parseInt(DS_DATE.substr(2, 2), 16), 2);
				var DS_YY = Pad(parseInt(DS_DATE.substr(4, 2), 16), 2);
				
				fx += lx; lx = 6;
				var DS_TIME = d.substr(fx, lx);
				var DS_HH = Pad(parseInt(DS_TIME.substr(0, 2), 16), 2);
				var DS_MI = Pad(parseInt(DS_TIME.substr(2, 2), 16), 2);
				var DS_SS = Pad(parseInt(DS_TIME.substr(4, 2), 16), 2);
				var DATA_STAMP = "20"+DS_YY+"-"+DS_MM+"-"+DS_DD+" "+DS_HH+":"+DS_MI+":"+DS_SS;
				
				var RTC_TIME = DS_HH+"."+DS_MI;
				
				fx += lx; lx = 30;
				IMEI_NO = '';
				for(var i = fx; i<fx+lx; i+=2){
					IMEI_NO += String.fromCharCode(parseInt(d.substr(i,2), 16));
				}
				
				fx += lx; lx = 2;
				var SL_VOLTAGE = parseInt(d.substr(fx, lx), 16);
				fx += lx; lx = 2;
				var v1 = d.substr(fx,lx);
				fx += lx; lx = 2;
				var v2 = d.substr(fx,lx);
				var BT_VOLTAGE = HexToDec(String(v2)+String(v1));
				
				fx += lx; lx = 26;
				var IO_DATA = '';
				for(var i = fx; i<fx+lx; i+=2){
					IO_DATA += String(parseInt(d.substr(i,2), 16));
				}
				
				var OUTPUT_STATUS = IO_DATA.substr(6, 1);
				
				var DOOR_STATUS = IO_DATA.substr(12, 1);
				
				fx += lx; lx = 6;
				var IO_DATE = d.substr(fx, lx);
				var IO_DD = Pad(parseInt(IO_DATE.substr(0, 2), 16), 2);
				var IO_MM = Pad(parseInt(IO_DATE.substr(2, 2), 16), 2);
				var IO_YY = Pad(parseInt(IO_DATE.substr(4, 2), 16), 2);
				
				fx += lx; lx = 6;
				var IO_TIME = d.substr(fx, lx);
				var IO_HH = Pad(parseInt(IO_TIME.substr(0, 2), 16), 2);
				var IO_MI = Pad(parseInt(IO_TIME.substr(2, 2), 16), 2);
				var IO_SS = Pad(parseInt(IO_TIME.substr(4, 2), 16), 2);
				var IO_STAMP = "20"+IO_YY+"-"+IO_MM+"-"+IO_DD+" "+IO_HH+":"+IO_MI+":"+IO_SS;
				
				console.log("DATA STAMP: "+DATA_STAMP);
				console.log("IMEI_NO: "+IMEI_NO);
				console.log("SL VOTLTAGE: "+SL_VOLTAGE);
				console.log("BT VOLTAGE: "+BT_VOLTAGE);
				console.log("IO DATA: "+IO_DATA);
				console.log("IO STAMP: "+IO_STAMP);
				
				var DATA = d.substr(fx+lx, d.length);
				console.log(DATA);
				
				fx += lx; lx = 16;
				
				fx += lx; lx = 4;
				var mw0 = HexToDecimal(d.substr(fx, lx));
				console.log("MW0 "+mw0);
				
				fx += lx; lx = 4;
				var mw1 = HexToDecimal(d.substr(fx, lx));
				console.log("MW1 "+mw1);
				
				
				fx += lx; lx = 4;
				var v0 = HexToDecimal(d.substr(fx, lx));
				
				fx += lx; lx = 4;
				var v1 = HexToDecimal(d.substr(fx, lx));
				
				var S1 = ToFloat(UInt16(v1), UInt16(v0));
				console.log('MW2 '+S1);
				
				fx += lx; lx = 4;
				var v0 = HexToDecimal(d.substr(fx, lx));
				
				fx += lx; lx = 4;
				var v1 = HexToDecimal(d.substr(fx, lx));
				
				var S2 = ToFloat(UInt16(v1), UInt16(v0));
				console.log('MW4 '+S2);
				
				
				fx = 0; lx = 4;	//MW0
				var ON_CMD = parseInt(DATA.substr(fx, lx));
				
				fx += lx; lx = 4;	//MW1
				var OFF_CMD = parseInt(DATA.substr(fx, lx));
				
				fx += lx; lx = 112;	//MW29
				
				
				
				fx += lx; lx = 4;	//MW30
				var VALUE_OPEN_FB = parseInt(DATA.substr(fx, lx));
				
				fx += lx; lx = 4;	//MW31
				var VALUE_CLOSE_FB = parseInt(DATA.substr(fx, lx));
				
				fx += lx; lx = 4;	//MW32
				var VALUE_TRIP_FB = parseInt(DATA.substr(fx, lx));
				
				
				
			//	fx += lx; lx = 4;
			//	var LEVEL_IN_METER = d.substr(fx, lx);
				
				
			}
		}
		
    });
    sock.on('close', function(data) 
	{
        console.log('SOCKET CLOSING ');
		var idx = sockets.indexOf(this);
		if (idx != -1) 
		{
			sockets.splice(idx,1);
		}
		//console.log('TOTAL NUMBER OF CONNECTIONS: '+sockets.length);
    });
	sock.on('end', function() {
        console.log('SOCKET END ');
		var idx = sockets.indexOf(this);
		if (idx != -1) {
			sockets.splice(idx,1);
		}
		//console.log('TOTAL NUMBER OF CONNECTIONS: '+sockets.length);
    });
	sock.on('error', function(){
		console.log('ERROR IN SOCKET CONNECTION');
		var idx = sockets.indexOf(this);
		if (idx != -1) {
			sockets.splice(idx,1);
		}
		//console.log('TOTAL NUMBER OF CONNECTIONS: '+sockets.length);
	});
	sock.setKeepAlive(true);
}).on('error', function(err) {
	console.log('ERROR '+ err);
});
server.listen(PORT, HOST);

function UInt16(value) {
	return (value & 0xFFFF);
};
function ToFloat(r0, r1){
	var buffer = struct.pack("!HH", r0, r1)
	return struct.unpack("!f", buffer);
}
function Pad (str, max) {
	str = str.toString();
	return str.length < max ? Pad("0" + str, max) : str;
}
function hexval(str){
	var arr = [];
	for(var i=0; i<str.length-1; i+=2){
		arr.push(str.substr(i, 2));
	}
	var code = arr.reverse().join().replace(/,/g,'').toString();
	return parseInt(code, 16);
}


function HexToFloat(value){
	return new Buffer(value, 'hex').readFloatBE(0).toFixed(3);
}
function HexToDecimal(value){
	return parseInt(Pad(value,4), 16);
}
function HexToBin(value){
	var bytes = "";
	for(var i=0; i< value.length; i++){
		bytes += Pad(parseInt(value.substr(i, 1), 16).toString(2), 4);
	}
	return bytes;
}
function getHexToDecimal(v1,v2){
	return String(HexToDecimal(String(v2)+String(v1)));//+String(HexToDecimal(v2));
	//return String(HexToFloat(v1))+String(HexToFloat(v2));
}

function HexToDec(value){
	return parseInt(value, 16);
}