var mysql = require('mysql');
var empty = require('is-empty');
var moment = require("moment");
var schedule = require('node-schedule');

var HOST = '216.10.251.190';
var PORT = 32212;
var HTTP_PORT = 32217;

var MASTER_DATA = new Object();

var dateFormat = require('dateformat');
var interval = '';
var sockets = [];
var schedule_records = {};
var connection = mysql.createConnection({
	multipleStatements: true,
	host     : 'localhost',
	user     : 'i3wd_slc',
	password : 'xmwmce4celwi',
	database : 'i3wd_slc',
	dateStrings: [
		'DATE',
		'DATETIME'
	  ]
});

setTimeout(load_devices, 1000);
function load_devices(){
	var sql = "SELECT md.id, md.imei_no, ml.feeder_pillar_no, md.device_type, md.device_no, md.data_fault, ml.state_id, ml.zone_id, ml.ulb_id, ml.ward_no, ml.total_connection, ml.total_load, ml.location_lat, ml.location_lng, ml.no_of_fittings, ml.maintenance, mz.title as ulb_title, mz.on_time, mz.off_time, dld.total_kw as actual_load, dld.output_status, dld.data_stamp, dld.update_time "+
"FROM master_device AS md "+
"LEFT JOIN master_location AS ml ON ml.feeder_pillar_no = md.feeder_pillar_no "+
"LEFT JOIN master_zone AS mz ON mz.id = ml.ulb_id "+
"LEFT JOIN device_last_data AS dld ON dld.imei_no = md.imei_no;"

	connection.query(sql, function selectCb(err, results, fields) {
		if (err) console.log(err);
		else {
			if(results.length > 0){
				for(var i=0; i<results.length; i++){
					var imei_no = results[i].imei_no;
					if(!MASTER_DATA[imei_no]){
						MASTER_DATA[imei_no] = new Object();
						MASTER_DATA[imei_no]['TIME'] = 0;
						MASTER_DATA[imei_no]['REGISTERED'] = 1;
						MASTER_DATA[imei_no]['CONNECTION'] = '';
						MASTER_DATA[imei_no]['SCHEDULE_TIME'] = moment().subtract(1, 'day').format("YYYY-MM-DD HH:mm:ss");
						MASTER_DATA[imei_no]['IMEI_NO'] = imei_no;
						MASTER_DATA[imei_no]['ON_HITS'] = 0;
						MASTER_DATA[imei_no]['OFF_HITS'] = 0;
						MASTER_DATA[imei_no]['LAST_AMP_R'] = -1;
						MASTER_DATA[imei_no]['LAST_AMP_Y'] = -1;
						MASTER_DATA[imei_no]['LAST_AMP_B'] = -1;
						MASTER_DATA[imei_no]['STATE_ID'] = results[i].state_id;
						MASTER_DATA[imei_no]['ZONE_ID'] = results[i].zone_id;
						MASTER_DATA[imei_no]['ULB_ID'] = results[i].ulb_id;
						MASTER_DATA[imei_no]['FP_NO'] = results[i].feeder_pillar_no;
						MASTER_DATA[imei_no]['TOTAL_CONNECTION'] = results[i].no_of_fittings;
						MASTER_DATA[imei_no]['TOTAL_LOAD'] = results[i].total_load;
						MASTER_DATA[imei_no]['ACTUAL_LOAD'] = results[i].actual_load;
						MASTER_DATA[imei_no]['DEVICE_TYPE'] = results[i].device_type;
						MASTER_DATA[imei_no]['PREV_LOAD_DBID'] = '';
						MASTER_DATA[imei_no]['PREV_LOAD_TIME'] = '';
						MASTER_DATA[imei_no]['PREV_LOAD'] = '';
						MASTER_DATA[imei_no]['PREV_OVERVOLTAGE_TIME'] = '';
						MASTER_DATA[imei_no]['PREV_VOLTAGE_R'] = '';
						MASTER_DATA[imei_no]['PREV_VOLTAGE_Y'] = '';
						MASTER_DATA[imei_no]['PREV_VOLTAGE_B'] = '';
						MASTER_DATA[imei_no]['PREV_OVERVOLTAGE_DBID'] = '';
						MASTER_DATA[imei_no]['DEVICE_FAULT'] = parseInt(results[i].data_fault);
						MASTER_DATA[imei_no]['POWER_CUT'] = 0;
						MASTER_DATA[imei_no]['UPDATE_TIME'] = results[i].update_time;
					}
					MASTER_DATA[imei_no]['RTC_ON_TIME'] = results[i].on_time;
					MASTER_DATA[imei_no]['RTC_OFF_TIME'] = results[i].off_time;
					MASTER_DATA[imei_no]['MAINTENANCE'] = results[i].maintenance;
					
				}
				setTimeout(load_devices, 1000 * 60 * 10);
				//console.log("TOTAL RECORDS "+JSON.stringify(MASTER_DATA));
			}else{
				console.log("NO RECORDS");
			}
		}
	});
}

var rule = new schedule.RecurrenceRule();

rule.hour = new schedule.Range(9, 17);
rule.minute = 0;
var j = schedule.scheduleJob(rule, function(){
	console.log('CHECK SCHEDULE');
	
});