var net = require('net');
var moment = require("moment");
var empty = require('is-empty');
var dateFormat = require('dateformat');

var http = require('http');
var httpserver = http.createServer();
var socketio = require('socket.io')(httpserver);

var HOST = '103.211.218.36';
var PORT = 33349;
var HTTP_PORT = 33350;

var interval = '';

var fx = 0;
var lx = 6;

var DEVICES = new Object();
var MY_IMEI = '';


socketio.on('connection', function (httpsocket){
    var nb = 0;

    console.log('SocketIO > Connected socket ' + httpsocket.id);

    console.log('>>>>>> >>>'+socketio.engine.clientsCount);

    socketio.to('index').emit("myconnect", "everyone");

    httpsocket.to('index').emit("myconnect", "everyoned fdsff");

    httpsocket.emit('liverecord', DEVICES);

    httpsocket.on('getdata', function(param){
    	console.log('SENDING LIVE RECORD '+JSON.stringify(param));
    	httpsocket.emit('liverecord', param);
    });
    httpsocket.on('setcommand', function(command) {
    	console.log('--------- COMMAND ---------'+command);
    	
    	if(command == "START"){
    		var hexvalue = [];
    		var str = "4C494748544F4E";
    		for(var i = 0; i<str.length; i+=2){
		      hexvalue.push('0x'+str.substr(i,2));
		    }
		    hexvalue.push(0x0D);
		    hexvalue.push(0x0A);

    		var buf = new Buffer(hexvalue, "hex");
			DEVICES[MY_IMEI]['SOCKET'].write(buf);


    		console.log('STARTING');
    	}
    	else{
			var hexvalue = [];
    		var str = "4C494748544F46";
    		for(var i = 0; i<str.length; i+=2){
		      hexvalue.push('0x'+str.substr(i,2));
		    }
		    hexvalue.push(0x0D);
		    hexvalue.push(0x0A);

    		var buf = new Buffer(hexvalue, "hex");
			DEVICES[MY_IMEI]['SOCKET'].write(buf);
    		console.log('STOPING');
    	}
    	/*var devices = new Array();
    	for (const [key, value] of Object.entries(MASTER_DATA)) {
			if(areacode == value.ULB_CODE){
				devices.push(value);
			}
		}
		var result = new Object();
		result.time = moment().format("YYYY-MM-DD HH:mm:ss");
		result.devices = devices;
		httpsocket.emit('datarecieved', result);*/
    });

    httpsocket.on('disconnect', function () {
        console.log('SocketIO : Received ' + nb + ' messages');
        console.log('SocketIO > Disconnected socket ' + httpsocket.id);
    });
});
httpserver.listen(HTTP_PORT);

var server = net.createServer(function(sock) {
    console.log('SERVER: ' + sock.remoteAddress +':'+ sock.remotePort);
	
    sock.on('data', function(data) 
	{
		var dt = new Date();
		var buff = Buffer.from(data, 'utf8');
		var hexdata = buff.toString('hex');
		console.log('ORIGINAL: ' + hexdata);
		
		writeLog('009900', d);


		var regExp = /(?<=5b)(.*)(?=5d)/;
        var matches = hexdata.match(regExp) 

        if(!empty(matches)){
        	var d = matches[1];
		
			console.log(">>>   "+d);
			
			if(d != ""){
			    var STATUS = "";
				var TYPE = "";
				var ACTUAL_DATA = d;
				var ACTUALDATALENGTH = d.length;

				var fx = 0; 
				var lx = 0;
				
				fx += lx; lx = 6;
				var DS_DATE = d.substr(fx, lx);
				var DS_DD = Pad(parseInt(DS_DATE.substr(0, 2), 16), 2);
				var DS_MM = Pad(parseInt(DS_DATE.substr(2, 2), 16), 2);
				var DS_YY = Pad(parseInt(DS_DATE.substr(4, 2), 16), 2);
				
				fx += lx; lx = 6;
				var DS_TIME = d.substr(fx, lx);
				var DS_HH = Pad(parseInt(DS_TIME.substr(0, 2), 16), 2);
				var DS_MI = Pad(parseInt(DS_TIME.substr(2, 2), 16), 2);
				var DS_SS = Pad(parseInt(DS_TIME.substr(4, 2), 16), 2);
				var DATA_STAMP = DS_YY+"-"+DS_MM+"-"+DS_DD+" "+DS_HH+":"+DS_MI+":"+DS_SS;
				
				var RTC_TIME = DS_HH+"."+DS_MI;
				
				
				fx += lx; lx = 30;
				IMEI_NO = '';
				for(var i = fx; i<fx+lx; i+=2){
					IMEI_NO += String.fromCharCode(parseInt(d.substr(i,2), 16));
				}				
				if(IMEI_NO == '000000000000000'){
					console.log('WRONG IMEI NO');
					return false;
				}
				
				
				fx += lx; lx = 2;
				var SL_VOLTAGE = parseInt(d.substr(fx, lx), 16);
				fx += lx; lx = 2;
				var v1 = d.substr(fx,lx);
				fx += lx; lx = 2;
				var v2 = d.substr(fx,lx);
				var BT_VOLTAGE = HexToDec(String(v2)+String(v1));
				
				fx += lx; lx = 26;
				var DIGITAL_OUTPUT = '';
				for(var i = fx; i<fx+lx; i+=2){
					DIGITAL_OUTPUT += String(parseInt(d.substr(i,2), 16));
				}
				
				var OUTPUT_STATUS = DIGITAL_OUTPUT.substr(6, 1);
				
				var ACTUAL_DATA = d;
				var ACTUALDATALENGTH = d.length;
				
				//fx += lx; lx = 6;
				//var DIGITAL_INPUT = d.substr(fx, lx);
				var DOOR_STATUS = DIGITAL_OUTPUT.substr(12, 1);
				
				fx += lx; lx = 6;
				var IO_DATE = d.substr(fx, lx);
				var IO_DD = Pad(parseInt(IO_DATE.substr(0, 2), 16), 2);
				var IO_MM = Pad(parseInt(IO_DATE.substr(2, 2), 16), 2);
				var IO_YY = Pad(parseInt(IO_DATE.substr(4, 2), 16), 2);
				
				fx += lx; lx = 6;
				var IO_TIME = d.substr(fx, lx);
				var IO_HH = Pad(parseInt(IO_TIME.substr(0, 2), 16), 2);
				var IO_MI = Pad(parseInt(IO_TIME.substr(2, 2), 16), 2);
				var IO_SS = Pad(parseInt(IO_TIME.substr(4, 2), 16), 2);
				var IO_STAMP = IO_YY+"-"+IO_MM+"-"+IO_DD+" "+IO_HH+":"+IO_MI+":"+IO_SS;

				if(IO_YY == 0){
					var now = new Date();
					IO_STAMP = dateFormat(now, "yyyy-mm-dd HH:MM:ss");
				}
				if(empty(DEVICES[IMEI_NO])){
					DEVICES[IMEI_NO] = new Object();
				}
				DEVICES[IMEI_NO]['OUTPUT_STATUS'] = OUTPUT_STATUS;
				DEVICES[IMEI_NO]['DATA_STAMP'] = DATA_STAMP;
				DEVICES[IMEI_NO]['SL_VOLTAGE'] = SL_VOLTAGE;
				DEVICES[IMEI_NO]['SOCKET'] = sock;

				MY_IMEI = IMEI_NO;

				console.log("DATALENGTH "+ ACTUALDATALENGTH);
				console.log("DATASTAMP "+DATA_STAMP);
				console.log("IMEI_NO "+IMEI_NO);
				console.log("SL_VOLTAGE "+ SL_VOLTAGE);
				console.log("BT_VOLTAGE "+ BT_VOLTAGE);
				console.log("DIGITAL_OUTPUT "+DIGITAL_OUTPUT);
				console.log("OUTPUT_STATUS "+ OUTPUT_STATUS);
				console.log("DOOR_STATUS "+ DOOR_STATUS);
				console.log("IO_STAMP "+IO_STAMP);
			}
        }
		
    });
    sock.on('close', function(data) 
	{
        console.log('SOCKET CLOSING ');
    });
	sock.on('end', function() {
        console.log('SOCKET END ');
    });
	sock.on('error', function(){
		console.log('ERROR IN SOCKET CONNECTION');
	});
	sock.setKeepAlive(true);
}).on('error', function(err) {
	console.log('ERROR '+ err);
});
server.listen(PORT, HOST);

server.on('connection', function(sock)
{
	console.log('SOCKET CONNECTED....');

	var now = new Date();
	var newdate = dateFormat(now, "ddmmyyHHMMss");
	
	var hexvalue = [0x52,0x54,0x43,0x2C];
	for(var i = 0; i<12; i+=2){
		hexvalue.push('0x'+newdate.substr(i,2));
	}
	hexvalue.push('0x0D');
	hexvalue.push('0x0A');
	
	var buff = new Buffer(hexvalue, "hex");
	sock.write(buff);
});
console.log('SERVER LISTENING ON ' + HOST +':'+ PORT);

function writeLog(IMEI_NO, DATA, TYPE){
	var d = new Date();
	//var time = dateFormat(d, "isoDateTime");
	
	//var file = d.getUTCFullYear()+"-"+(d.getUTCMonth() + 1)+"-"+(d.getUTCDate())+".txt";
	var file = "smog.txt";
	
	var fs = require('fs');
	const path = require('path');
	fs.exists(path.normalize(__dirname+'../../../../logs/'+file), function(exist){
		if(exist){
			var str = IMEI_NO + "," + DATA;
			fs.appendFile(path.normalize(__dirname+'../../../../logs/'+file), '\r\n'+str, function(err1) {
				if (err1) console.log(err1);
			});
		}else{
			fs.writeFile(path.normalize(__dirname+'../../../../logs/'+file), '--- Start Logging ---', function(err2) {
				if (err2) console.log(err2);
				console.log('NEW LOG FILE CREATED!');
			});
		}
	});
}

function Pad (str, max) {
	str = str.toString();
	return str.length < max ? Pad("0" + str, max) : str;
}
function hexval(str){
	var arr = [];
	for(var i=0; i<str.length-1; i+=2){
		arr.push(str.substr(i, 2));
	}
	var code = arr.reverse().join().replace(/,/g,'').toString();
	return parseInt(code, 16);
}
function HexToFloat(value){
	return new Buffer(value, 'hex').readFloatBE(0).toFixed(3);
}
function HexToDecimal(value){
	return parseInt(Pad(value,4), 16);
}
function HexToBin(value){
	var bytes = "";
	for(var i=0; i< value.length; i++){
		bytes += Pad(parseInt(value.substr(i, 1), 16).toString(2), 4);
	}
	return bytes;
}
function getHexToDecimal(v1,v2){
	return String(HexToDecimal(String(v2)+String(v1)));//+String(HexToDecimal(v2));
	//return String(HexToFloat(v1))+String(HexToFloat(v2));
}

function HexToDec(value){
	return parseInt(value, 16);
}