var net = require('net');
var mysql = require('mysql');
var moment = require("moment");
var http = require('http');
var httpserver = http.createServer();
var socketio = require('socket.io')(httpserver);
var empty = require('is-empty');

var schedule = require('node-schedule');

var HOST = '103.211.218.36';
var PORT = 32290;
var HTTP_PORT = 32291;

var dateFormat = require('dateformat');
var interval = '';
var sockets = [];
var sockets_info = [];
var connection = mysql.createConnection({
	multipleStatements: true,
	host     : 'localhost',
	user     : 'i3wd_slc',
	password : 'xmwmce4celwi',
	database : 'i3wd_scada',
	dateStrings: [
		'DATE',
		'DATETIME'
	  ]
});
var dbcols = new Array();
var tldcols = new Array();
var cname = "";
var cvalue = "";
var dt = new Date();
var ST = dt.getTime();
var dt = new Date();
var CT = dt.getTime();
var TB_DEVICE = 'master_device';
var TB_DEVICE_RECEIVED = 'device_received_data';
var TB_DEVICE_LASTDATA = 'device_last_data';
var TB_OVERVOLTAGE = 'report_overvoltage';
var TB_LOAD = 'report_overload';
var AMP_LIMIT = 1300;
var VOLTAGE_LIMIT = 28000;
var MASTER_DATA = new Object();
var DISCONNECTION_TIME_LIMIT = 30;
var CORRECTION_AMP = 2.3;

var data_check = new Object();

var IMEI_NOT_FOUND = new Object();

var ONESEC = 1000;
var ONEMIN = 60 * 1000;
var TENMIN = 10 * 60 * 1000;
var ONEHOUR = 60 * 60 * 1000;
var TWELVEHOURS = 12 * 60 * 60 * 1000;
var ONEDAY = 24 * 60 * 60 * 1000;

var DELAY = 15;

var METER_SINGLE_PHASE = 1;
var METER_THREE_PHASE = 3;


var fx = 0;
var lx = 6;

var ULB_INDEX = 0;


setTimeout(load_devices, 1000);
function load_devices(){
	var sql = "SELECT md.id, md.imei_no, md.sms_on, md.sms_off, md.sms_mobile, dld.data_stamp, dld.update_time "+
"FROM master_device AS md "+
"LEFT JOIN device_last_data AS dld ON dld.imei_no = md.imei_no;"

	connection.query(sql, function selectCb(err, results, fields) {
		if (err) console.log(err);
		else {
			if(results.length > 0){
				for(var i=0; i<results.length; i++){
					var imei_no = results[i].imei_no;
					if(!MASTER_DATA[imei_no]){
						MASTER_DATA[imei_no] = new Object();
						MASTER_DATA[imei_no]['TIME'] = 0;
						MASTER_DATA[imei_no]['REGISTERED'] = 1;
						MASTER_DATA[imei_no]['CONNECTION'] = '';
						MASTER_DATA[imei_no]['SCHEDULE_TIME'] = moment().subtract(1, 'day').format("YYYY-MM-DD HH:mm:ss");
						MASTER_DATA[imei_no]['IMEI_NO'] = imei_no;
						MASTER_DATA[imei_no]['ON_HITS'] = 0;
						MASTER_DATA[imei_no]['OFF_HITS'] = 0;
						MASTER_DATA[imei_no]['LAST_AMP_R'] = -1;
						MASTER_DATA[imei_no]['LAST_AMP_Y'] = -1;
						MASTER_DATA[imei_no]['LAST_AMP_B'] = -1;
						MASTER_DATA[imei_no]['PREV_LOAD_DBID'] = '';
						MASTER_DATA[imei_no]['PREV_LOAD_TIME'] = '';
						MASTER_DATA[imei_no]['PREV_LOAD'] = '';
						MASTER_DATA[imei_no]['PREV_OVERVOLTAGE_TIME'] = '';
						MASTER_DATA[imei_no]['PREV_VOLTAGE_R'] = '';
						MASTER_DATA[imei_no]['PREV_VOLTAGE_Y'] = '';
						MASTER_DATA[imei_no]['PREV_VOLTAGE_B'] = '';
						MASTER_DATA[imei_no]['PREV_OVERVOLTAGE_DBID'] = '';
						MASTER_DATA[imei_no]['METER_PHASE_TYPE'] = '';
						MASTER_DATA[imei_no]['POWER_CUT'] = 0;
						MASTER_DATA[imei_no]['INPUT1'] = -1;
						MASTER_DATA[imei_no]['INPUT2'] = -1;
						MASTER_DATA[imei_no]['INPUT3'] = -1;
						MASTER_DATA[imei_no]['INPUT4'] = -1;
						MASTER_DATA[imei_no]['INPUT5'] = -1;
						MASTER_DATA[imei_no]['OUTPUT1'] = -1;
						MASTER_DATA[imei_no]['OUTPUT2'] = -1;

						MASTER_DATA[imei_no]['SMS_ON'] = results[i].sms_on;
						MASTER_DATA[imei_no]['SMS_OFF'] = results[i].sms_off;
						MASTER_DATA[imei_no]['SMS_MOBILE'] = results[i].sms_mobile;

						MASTER_DATA[imei_no]['UPDATE_TIME'] = results[i].update_time;
					}
				}
				setTimeout(load_devices, ONEHOUR);
				//console.log("TOTAL RECORDS "+JSON.stringify(MASTER_DATA));
			}else{
				console.log("NO RECORDS");
			}
		}
	});
}


var server = net.createServer(function(sock) {
    console.log('SERVER: ' + sock.remoteAddress +':'+ sock.remotePort);
	
    
    sock.on('data', function(data) 
	{
		var dt = new Date();
		console.log("DATA :"+data);
		writeLog("ORIGINAL ", data);
		
		ST = dt.getTime();

		var buff = new Buffer(data, 'utf8');
		var d = buff.toString('hex');

		//var d = data.toString();
		
		console.log("DATA :"+d.length+" "+d);
		//writeLog("ORIGINAL "+ d);

		return;
		
		var sx = 0;
		var ex = 0;
		var stag = '';
		var etag = '';
		var dcuarr = [];
		var ctrlarr = [];
		var stag_dcu = '5b';
		var etag_dcu = '5d';
		var dlen = {DCU:246,CTRL:82};

		do{
			ex = 2;
			stag = d.substring(sx, sx+ex);
			console.log("FIND TAG: "+stag);
			if(stag == stag_dcu){
				sx += ex;
				ex = dlen.DCU;
				var dcustr = d.substring(sx, sx+ex);
				sx += ex;
				ex = 2;
				etag = d.substring(sx, sx+ex);
				if(etag == etag_dcu){
					dcuarr.push(dcustr);
				}else{
					console.log('ERROR IN DCU DATA');
				}
				console.log(stag+" "+etag+" | ");	
			}
			if(sx >= d.length){
				break;
			}
			sx += ex;
		}while(true)

		if(dcuarr.length == 0){
			console.log('DATA NOT FOUND ');
			return;
		}
		d = dcuarr[0];

		var fx = 0; 
		var lx = 0;

		fx += lx; lx = 6;
		var DS_DATE = d.substr(fx, lx);
		var DS_DD = Pad(parseInt(DS_DATE.substr(0, 2), 16), 2);
		var DS_MM = Pad(parseInt(DS_DATE.substr(2, 2), 16), 2);
		var DS_YY = Pad(parseInt(DS_DATE.substr(4, 2), 16), 2);
		
		fx += lx; lx = 6;
		var DS_TIME = d.substr(fx, lx);
		var DS_HH = Pad(parseInt(DS_TIME.substr(0, 2), 16), 2);
		var DS_MI = Pad(parseInt(DS_TIME.substr(2, 2), 16), 2);
		var DS_SS = Pad(parseInt(DS_TIME.substr(4, 2), 16), 2);
		var DS_STAMP = DS_YY+"-"+DS_MM+"-"+DS_DD+" "+DS_HH+":"+DS_MI+":"+DS_SS;


		fx += lx; lx = 30;
		var IMEI_NO = '';
		for(var i = fx; i<fx+lx; i+=2){
			IMEI_NO += String.fromCharCode(parseInt(d.substr(i,2), 16));
		}

		console.log("IMEI "+IMEI_NO);
		

		var skip = false;
		dt = new Date();

		if(empty(MASTER_DATA[IMEI_NO])){
			console.log(IMEI_NO+" NOT FOUND");
			if(!IMEI_NOT_FOUND[IMEI_NO]){
				IMEI_NOT_FOUND[IMEI_NO] = new Object();	
			}

			IMEI_NOT_FOUND[IMEI_NO]['TIME'] = moment().format("YYYY-MM-DD HH:mm:ss");
			IMEI_NOT_FOUND[IMEI_NO]['DATA'] = d;

			return;
		}

		writeLog(IMEI_NO, data);
		

		fx += lx; lx = 2;
		var SL_VOLTAGE = parseInt(d.substr(fx, lx), 16);
		fx += lx; lx = 2;
		var v1 = d.substr(fx,lx);
		fx += lx; lx = 2;
		var v2 = d.substr(fx,lx);
		var BT_VOLTAGE = HexToDec(String(v2)+String(v1));

		fx += lx; lx = 26;
		var IO_DATA = '';
		for(var i = fx; i<fx+lx; i+=2){
			IO_DATA += String(parseInt(d.substr(i,2), 16));
		}


		fx += lx; lx = 6;
		var datestr = d.substr(fx, lx);
		var dd = datestr.substr(0, 2);
		var mm = datestr.substr(2, 2);
		var yy = datestr.substr(4, 2);
		var rec_date = yy+"-"+mm+"-"+dd;
		
		fx += lx; lx = 6;
		var timestr = d.substr(fx, lx);
		var hh = timestr.substr(0, 2);
		var mmj = timestr.substr(2, 2);
		var ss = timestr.substr(4, 2);
		var rec_time = hh+":"+mmj+":"+ss;

		
		
		if(empty(sock.imei_no)){
			sock.imei_no = IMEI_NO;
		}
		
		console.log(IMEI_NO+' '+moment().format("YYYY-MM-DD HH:mm:ss"));
		
		
		MASTER_DATA[IMEI_NO]['TIME'] = moment().format("YYYY-MM-DD HH:mm:ss");
		MASTER_DATA[IMEI_NO]['CONNECTION'] = sock;
		
		
		var DATA = d;
		var DATA_STAMP = rec_date+" "+rec_time;
		var STATUS = "";
		var TYPE = "";
		var ACTUAL_DATA = d;
		var ACTUALDATALENGTH = d.length;

		/********************** CURCUIT BREAKER DATA **********************/
		
		
		var VOLTAGE_R,VOLTAGE_Y,VOLTAGE_B,AMP_R,AMP_Y,AMP_B;

		fx += lx; lx = 8; VOLTAGE_R = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8; VOLTAGE_Y = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8; VOLTAGE_B = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8; AMP_R = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8; AMP_Y = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8; AMP_B = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));

		var AMP = (AMP_R + AMP_Y + AMP_B)/3;

		/*console.log('IMEI NO: '+IMEI_NO);
		console.log('DATE: '+rec_date);
		console.log('TIME: '+rec_time);
		console.log('SL VOLTAGE: '+SL_VOLTAGE);
		console.log('BT VOLTAGE: '+BT_VOLTAGE);
		console.log('VOLTAGE R: '+VOLTAGE_R);
		console.log('VOLTAGE Y: '+VOLTAGE_Y);
		console.log('VOLTAGE B: '+VOLTAGE_B);
		console.log('AMP R: '+AMP_R);
		console.log('AMP Y: '+AMP_Y);
		console.log('AMP B: '+AMP_B);*/

		var LAST_AMP = (MASTER_DATA[IMEI_NO]['LAST_AMP_R'] + MASTER_DATA[IMEI_NO]['LAST_AMP_Y'] + MASTER_DATA[IMEI_NO]['LAST_AMP_B'])/3;

		var flag = false;
		//if(LAST_AMP > 0 || AMP > 0){
			if(LAST_AMP == 0 && AMP > 0){
				smstxt = MASTER_DATA[IMEI_NO]['SMS_ON'];
            	flag = true;
			}else if(LAST_AMP > 0 && AMP == 0){
				smstxt = MASTER_DATA[IMEI_NO]['SMS_OFF'];
				flag = true;

				var sql = "INSERT INTO report_trips (imei_no, insert_time) values ('"+IMEI_NO+"', NOW())";
				connection.query(sql, function selectCb(err, results, fields) {
					if (err){
						console.log(err);
					}else{ 
						console.log("BREAKER TRIP INFORMATION ADDED");
					}
				});
			}
			if(flag){
				var mobile = MASTER_DATA[IMEI_NO]['SMS_MOBILE'];
			
				var url = 'http://sms.bmwebmedia.com/shn/api/pushsms.php?usr=624402&key=0105qJp302aRslvQCRCgLIpYL8meS0&sndr=RNDSMS&ph='+mobile+'&text='+smstxt+'&rpt=1';
				var request = http.request(url, function (res) {
				    var data = '';
				    res.on('data', function (chunk) {
				        data += chunk;
				    });
				    res.on('end', function () {
				        console.log(data);
				    });
				});
				request.on('error', function (e) {
				    console.log(e.message);
				});
				request.end();
			}
		//}
		flag = false;

		
		MASTER_DATA[IMEI_NO]['LAST_AMP_R'] = AMP_R;
		MASTER_DATA[IMEI_NO]['LAST_AMP_Y'] = AMP_Y;
		MASTER_DATA[IMEI_NO]['LAST_AMP_B'] = AMP_B;

		
		fx += lx; lx = 8;
		var KW = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		MASTER_DATA[IMEI_NO]['PREV_LOAD'] = KW;

		fx += lx; lx = 8;
		var PF = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));

		fx += lx; lx = 8;
		var FREQUENCY = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));

		fx += lx; lx = 8;
		var KVA = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));

		
		MASTER_DATA[IMEI_NO]['PREV_VOLTAGE_R'] = VOLTAGE_R;
		MASTER_DATA[IMEI_NO]['PREV_VOLTAGE_Y'] = VOLTAGE_Y;
		MASTER_DATA[IMEI_NO]['PREV_VOLTAGE_B'] = VOLTAGE_B;
		
		fx += lx; lx = 8;
		var KWH = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));

		fx += lx; lx = 8;
		var SPARE1 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));

		fx += lx; lx = 8;
		var SPARE2 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));


		fx += lx; lx = 8;
		var INPUT1 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8;
		var INPUT2 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8;
		var INPUT3 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8;
		var INPUT4 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8;
		var INPUT5 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));

		fx += lx; lx = 8;
		var OUTPUT1 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8;
		var OUTPUT2 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));

		if(MASTER_DATA[IMEI_NO]['INPUT1']>-1 || MASTER_DATA[IMEI_NO]['INPUT2']>-1 || MASTER_DATA[IMEI_NO]['INPUT3']>-1 || MASTER_DATA[IMEI_NO]['INPUT4']>-1 || MASTER_DATA[IMEI_NO]['INPUT5']>-1){
			if(MASTER_DATA[IMEI_NO]['INPUT1'] != INPUT1){
				/*if(INPUT1>0){
	            	smstxt = MASTER_DATA[IMEI_NO]['SMS_ON'];
	            	flag = true;
				}else{
					smstxt = MASTER_DATA[IMEI_NO]['SMS_OFF'];
					flag = false;

					// case breaker trip

					var sql = "INSERT INTO report_trips (imei_no, insert_time) values ('"+IMEI_NO+"', NOW())";
					connection.query(sql, function selectCb(err, results, fields) {
						if (err){
							console.log(err);
						}else{ 
							console.log("BREAKER TRIP INFORMATION ADDED");
						}
					});  
				}
				var mobile = MASTER_DATA[IMEI_NO]['SMS_MOBILE'];
				
				var url = 'http://sms.bmwebmedia.com/shn/api/pushsms.php?usr=624402&key=0105qJp302aRslvQCRCgLIpYL8meS0&sndr=RNDSMS&ph='+mobile+'&text='+smstxt+'&rpt=1';
				var request = http.request(url, function (res) {
				    var data = '';
				    res.on('data', function (chunk) {
				        data += chunk;
				    });
				    res.on('end', function () {
				        console.log(data);
				    });
				});
				request.on('error', function (e) {
				    console.log(e.message);
				});
				request.end();*/
			}
		}
		if(MASTER_DATA[IMEI_NO]['OUTPUT1']>-1 || MASTER_DATA[IMEI_NO]['OUTPUT2']>-1){
			if(MASTER_DATA[IMEI_NO]['OUTPUT1'] != OUTPUT1 && OUTPUT1>0){

			}
			if(MASTER_DATA[IMEI_NO]['OUTPUT2'] != OUTPUT2 && OUTPUT2>0){
				
			}
		}

		if(MASTER_DATA[IMEI_NO]['INPUT1'] != INPUT1){
			var sql = "INSERT INTO record_on_off (imei_no, io_status, insert_time) values ('"+IMEI_NO+"', "+INPUT1+", NOW())";
			connection.query(sql, function selectCb(err, results, fields) {
				if (err){
					console.log(err);
				}else{ 
					console.log("BREAKER ON OFF INFORMATION ADDED");
				}
			});
		}

		MASTER_DATA[IMEI_NO]['INPUT1'] = INPUT1;
		MASTER_DATA[IMEI_NO]['INPUT2'] = INPUT2;
		MASTER_DATA[IMEI_NO]['INPUT3'] = INPUT3;
		MASTER_DATA[IMEI_NO]['INPUT4'] = INPUT4;
		MASTER_DATA[IMEI_NO]['INPUT5'] = INPUT5;
		MASTER_DATA[IMEI_NO]['OUTPUT1'] = OUTPUT1;
		MASTER_DATA[IMEI_NO]['OUTPUT2'] = OUTPUT2;
		
		var now = new Date();
		var created_at = dateFormat(now, "isoDateTime");
		

		var sql = "INSERT INTO "+TB_DEVICE_RECEIVED+" (imei_no, data_stamp, supply, battery, data, datalength, voltage_r, voltage_y, voltage_b, amp_r, amp_y, amp_b, pf, kw, kva, kwh, frequency, spare_1, spare_2, input_1, input_2, input_3, input_4, input_5, output_1, output_2, update_time) values ('"+IMEI_NO+"','"+DATA_STAMP+"','"+SL_VOLTAGE+"','"+BT_VOLTAGE+"','"+ACTUAL_DATA+"','"+ACTUALDATALENGTH+"','"+VOLTAGE_R+"','"+VOLTAGE_Y+"','"+VOLTAGE_B+"','"+AMP_R+"','"+AMP_Y+"','"+AMP_B+"','"+PF+"','"+KW+"','"+KVA+"','"+KWH+"','"+FREQUENCY+"','"+SPARE1+"','"+SPARE2+"','"+INPUT1+"','"+INPUT2+"','"+INPUT3+"','"+INPUT4+"','"+INPUT5+"','"+OUTPUT1+"','"+OUTPUT2+"', NOW())";
		//console.log(sql);
		connection.query(sql, function selectCb(err, results, fields) {
			if (err){
				console.log("ERROR DATA LENGTH "+data.length);
				console.log("ERROR IMEI_NO "+IMEI_NO);
				console.log(err);
			}else{ 
				//console.log("INSERT DATA OK");
				connection.query("UPDATE "+TB_DEVICE_LASTDATA+" SET data_stamp='"+DATA_STAMP+"', supply='"+SL_VOLTAGE+"', battery='"+BT_VOLTAGE+"', data='"+ACTUAL_DATA+"', datalength='"+ACTUALDATALENGTH+"', voltage_r='"+VOLTAGE_R+"', voltage_y='"+VOLTAGE_Y+"', voltage_b='"+VOLTAGE_B+"', amp_r='"+AMP_R+"', amp_y='"+AMP_Y+"', amp_b='"+AMP_B+"', pf='"+PF+"', kw='"+KW+"', kva='"+KVA+"', kwh='"+KWH+"', frequency='"+FREQUENCY+"', spare_1='"+SPARE1+"', spare_2='"+SPARE2+"', input_1='"+INPUT1+"', input_2='"+INPUT2+"', input_3='"+INPUT3+"', input_4='"+INPUT4+"', input_5='"+INPUT5+"', output_1='"+OUTPUT1+"', output_2='"+OUTPUT2+"', update_time=NOW() WHERE imei_no = '"+IMEI_NO+"'",
				function selectCb(err, results, fields) {
					if (err) {
						console.log(err);
					}else{ 
						//console.log("INSERT TRANS LAST DATA OK");
					}
				});
			}
		});   
    });
    sock.on('close', function(data) 
	{
        console.log('SOCKET CLOSING ');
		var idx = sockets.indexOf(this);
		if (idx != -1) 
		{
			sockets.splice(idx,1);
		}
		//console.log('TOTAL NUMBER OF CONNECTIONS: '+sockets.length);
    });
	sock.on('end', function() {
        console.log('SOCKET END ');
		var idx = sockets.indexOf(this);
		if (idx != -1) {
			sockets.splice(idx,1);
		}
		//console.log('TOTAL NUMBER OF CONNECTIONS: '+sockets.length);
    });
	sock.on('error', function(){
		console.log('ERROR IN SOCKET CONNECTION');
		var idx = sockets.indexOf(this);
		if (idx != -1) {
			sockets.splice(idx,1);
		}
		//console.log('TOTAL NUMBER OF CONNECTIONS: '+sockets.length);
	});
	sock.setKeepAlive(true);
}).on('error', function(err) {
	console.log('ERROR '+ err);
});
server.listen(PORT, HOST);


var schedule_records = {};
var rule = new schedule.RecurrenceRule();

rule.hour = new schedule.Range(6, 7);
rule.minute = 4;
var j = schedule.scheduleJob(rule, function(){
	console.log('DAILY REPORT SCHEDULE');

	return;
	
	var nodeMailer = require('nodemailer');
	let transporter = nodeMailer.createTransport({
		host: '103-50-161-36.webhostbox.net',
		port: 587,
		secure: false,
		auth: {
			user: 'reports@rapturous.co.in',
			pass: 'gmvxgysygw20'
		}
	});


	var current_time = moment();
	var end_time = moment(moment().format('YYYY-MM-DD')+' 06:05:00').format('YYYY-MM-DD hh:mm:ss');
	var start_time = moment(moment().format('YYYY-MM-DD')+' 06:05:00').subtract(1, 'days').format('YYYY-MM-DD hh:mm:ss');
	var diff = current_time.diff(end_time, 'seconds');

	if(diff < 0){
		end_time = moment(moment().format('YYYY-MM-DD')+' 06:05:00').subtract(1, 'days').format('YYYY-MM-DD hh:mm:ss');
		start_time = moment(moment().format('YYYY-MM-DD')+' 06:05:00').subtract(2, 'days').format('YYYY-MM-DD hh:mm:ss');
	}

	var sql = "SELECT md.imei_no, md.title, '19.5 hr' avalibility, '24 hr' network_status, (SELECT count(id) FROM report_trips rt WHERE rt.imei_no=md.imei_no AND rt.insert_time >= '"+start_time+"' AND rt.insert_time <= '"+end_time+"') power_trips, '16 hr' on_hours, dld.datalength, dld.voltage_r, dld.voltage_y, dld.voltage_b, dld.amp_r, dld.amp_y, dld.amp_b, dld.kw, dld.pf, dld.frequency, dld.kva, dld.kwh, (SELECT spare_1 FROM device_received_data drd WHERE drd.imei_no = md.imei_no AND drd.update_time >='"+start_time+"' AND drd.update_time <= '"+end_time+"' ORDER BY drd.update_time DESC LIMIT 1) as spare_1, (SELECT spare_2 FROM device_received_data drd WHERE drd.imei_no = md.imei_no AND drd.update_time >='"+start_time+"' AND drd.update_time <= '"+end_time+"' ORDER BY drd.update_time DESC LIMIT 1) as spare_2, dld.input_1, dld.input_2, dld.input_3, IFNULL(dld.supply, '') as supply, IFNULL(dld.update_time, '') as update_time, (SELECT kwh FROM device_received_data drd WHERE drd.imei_no = md.imei_no AND drd.update_time >='"+start_time+"' AND drd.update_time <= '"+end_time+"' ORDER BY drd.update_time ASC LIMIT 1) as kwh_start, (SELECT kwh FROM device_received_data drd WHERE drd.imei_no = md.imei_no AND drd.update_time >='"+start_time+"' AND drd.update_time <= '"+end_time+"' ORDER BY drd.update_time DESC LIMIT 1) as kwh_end FROM master_device as md LEFT JOIN device_last_data as dld ON dld.imei_no = md.imei_no ORDER BY md.position ASC;";

	var htmlbody = '';
	connection.query(sql, function selectCb(err, results, fields) {
		if (err) console.log(err);
		else {
			if(results.length > 0){
				
				var htmlbody = '<table><tr><td>Daily Report</td></tr><tr><td>'+start_time+' TO '+end_time+'</td></tr><tr><td><table style="border-collapse:collapse; border: 1px solid #cccccc;"><tr style="background-color:#999999;color:#ffffff;"><td style="padding-right:10px">Equipment Name</td><td style="padding-right:10px">Power Avalibility</td><td style="padding-right:10px">No of Power Trip (Nos)</td><td style="padding-right:10px">Equipment on (Hrs)</td><td style="padding-right:10px">Power Consumption (KWH)</td></tr>';
				var bg_white = '#ffffff';
				var bg_grey = '#f2f2f2';
				for (var i = 0; i < results.length; i++) {
					var d = results[i];
					var pa = parseInt(d.spare_1/60)+':'+parseInt(d.spare_1%60);
					var pt = d.power_trips;
					var oh = parseInt(d.spare_2/60)+':'+parseInt(d.spare_2%60);
					var pc = 0;
					if(d.kwh_start != "" && d.kwh_end != ""){
						pc = parseInt(d.kwh_end) - parseInt(d.kwh_start);
					}else{
						pc = 0;
					}
					var bg_color = bg_grey;
					if(i%2 == 0){
						bg_color = bg_white;
					}
					htmlbody += '<tr style="background-color:'+bg_color+'"><td style="padding-right:10px">'+d.title+'</td><td style="padding-right:10px">'+pa+'</td><td style="padding-right:10px">'+pt+'</td><td style="padding-right:10px">'+oh+'</td><td style="padding-right:10px">'+pc+'</td></tr>';
				}
				htmlbody += '</table></td></tr></table>';
				//var imei_no = results[i].imei_no;


				const data = {
				 	subject: 'Daily Report: '+start_time+' To '+end_time,
					message: htmlbody
				};

				const querystring = require('querystring');
				var qs = querystring.stringify(data);
				var qslength = qs.length;

				const options = {
					host: '103.211.218.36',
					path: '/mail/index.php',
					method: 'POST',
					headers:{
				        'Content-Type': 'application/x-www-form-urlencoded',
				        'Content-Length': qslength
				    }
				}

				var request = http.request(options, function (res) {
				    var data = '';
				    res.on('data', function (chunk) {
				        data += chunk;
				    });
				    res.on('end', function () {
				        console.log(data);
				    });
				});
				request.on('error', function (e) {
				    console.log(e.message);
				});
				request.write(qs);
				request.end();


				/*let mailOptions = {
					from: 'reports@rapturous.co.in',
					to: 'prathvi.singh@gmail.com',
					subject: 'Daily Report',
					html: htmlbody
				};
				transporter.sendMail(mailOptions, (error, info) => {
					if (error) {
					 	 return console.log(error);
					}
					console.log('Message %s sent: %s', info.messageId, info.response);
				});*/
			}
		}
	});
});

function dailyconsumption(){
	var nodeMailer = require('nodemailer');
	let transporter = nodeMailer.createTransport({
		host: '103-50-161-36.webhostbox.net',
		port: 465,
		secure: true,
		auth: {
			user: 'reports@rapturous.co.in',
			pass: 'gmvxgysygw20'
		}
	});

	var current_time = moment();
	var end_time = moment(moment().format('YYYY-MM-DD')+' 06:00:00');
	var start_time = moment(moment().format('YYYY-MM-DD')+' 06:00:00').subtract(1, 'days');
	var diff = current_time.diff(end_time, 'seconds');

	if(diff < 0){
		end_time = moment(moment().format('YYYY-MM-DD')+' 06:00:00').subtract(1, 'days');
		start_time = moment(moment().format('YYYY-MM-DD')+' 06:00:00').subtract(2, 'days');
	}

	var sql = "SELECT md.imei_no, md.title, '19.5 hr' avalibility, '24 hr' network_status, (SELECT count(id) FROM report_trips rt WHERE rt.imei_no=md.imei_no AND rt.insert_time >= '"+moment(start_time).format('YYYY-MM-DD hh:mm:ss')+"' AND rt.insert_time <= '"+moment(end_time).format('YYYY-MM-DD hh:mm:ss')+"') power_trips, '16 hr' on_hours, dld.datalength, dld.voltage_r, dld.voltage_y, dld.voltage_b, dld.amp_r, dld.amp_y, dld.amp_b, dld.kw, dld.pf, dld.frequency, dld.kva, dld.kwh, (SELECT MAX(spare_1) FROM device_received_data drd WHERE drd.imei_no = md.imei_no AND drd.update_time >='"+moment(start_time).format('YYYY-MM-DD hh:mm:ss')+"' AND drd.update_time <= '"+moment(end_time).format('YYYY-MM-DD hh:mm:ss')+"' ORDER BY drd.update_time ASC LIMIT 1) as spare_1, (SELECT MAX(spare_2) FROM device_received_data drd WHERE drd.imei_no = md.imei_no AND drd.update_time >='"+moment(start_time).format('YYYY-MM-DD hh:mm:ss')+"' AND drd.update_time <= '"+moment(end_time).format('YYYY-MM-DD hh:mm:ss')+"' ORDER BY drd.update_time ASC LIMIT 1) as spare_2, dld.input_1, dld.input_2, dld.input_3, IFNULL(dld.supply, '') as supply, IFNULL(dld.update_time, '') as update_time, (SELECT kwh FROM device_received_data drd WHERE drd.imei_no = md.imei_no AND drd.update_time >='"+moment(start_time).format('YYYY-MM-DD hh:mm:ss')+"' AND drd.update_time <= '"+moment(end_time).format('YYYY-MM-DD hh:mm:ss')+"' ORDER BY drd.update_time ASC LIMIT 1) as kwh_start, (SELECT kwh FROM device_received_data drd WHERE drd.imei_no = md.imei_no AND drd.update_time >='"+moment(start_time).format('YYYY-MM-DD hh:mm:ss')+"' AND drd.update_time <= '"+moment(end_time).format('YYYY-MM-DD hh:mm:ss')+"' ORDER BY drd.update_time DESC LIMIT 1) as kwh_end FROM master_device as md LEFT JOIN device_last_data as dld ON dld.imei_no = md.imei_no ORDER BY md.position ASC;";

	var htmlbody = '';
	connection.query(sql, function selectCb(err, results, fields) {
		if (err) console.log(err);
		else {
			if(results.length > 0){
				
				var htmlbody = '<table><tr><td>Daily Report</td></tr><tr><td>'+start_time+' TO '+end_time+'</td></tr><tr><td><table><tr><td>Equipment Name</td><td>Network Status (Up Time)</td><td>Power Avalibility</td><td>No of Power Trip (Nos)</td><td>Equipment on (Hrs)</td><td>Power Consumption (KWH)</td></tr>';
				for (var i = 0; i < results.length; i++) {
					var d = results[i];
					var pa = parseInt(d.spare_1/60)+':'+parseInt(d.spare_1%60);
					var pt = d.power_trips;
					var oh = parseInt(d.spare_2/60)+':'+parseInt(d.spare_2%60);
					var pc = 0;
					if(d.kwh_start != "" && d.kwh_end != ""){
						pc = parseInt(d.kwh_end) - parseInt(d.kwh_start);
					}else{
						pc = 0;
					}
					htmlbody += '<tr><td>'+d.title+'</td><td>24 Hrs</td><td>'+pa+'</td><td>'+pt+'</td><td>'+oh+'</td><td>'+pc+'</td></tr>';
				}
				htmlbody = '</table></td></tr></table>';
				//var imei_no = results[i].imei_no;

				const request = require('request');
				request.post(
					'http://103.211.218.36/mail/index.php',
					{
						json: {
					  		subject: 'Daily Report',
					  		message: htmlbody
						},
					},
					(error, res, body) => {
						if (error) {
					  		console.error(error)
					  	return
					}
					console.log(`statusCode: ${res.statusCode}`)
					console.log(body)
				})

				/*let mailOptions = {
					from: 'reports@rapturous.co.in',
					to: 'prathvi.singh@gmail.com',
					subject: 'Daily Report',
					html: htmlbody
				};
				transporter.sendMail(mailOptions, (error, info) => {
					if (error) {
					 	 return console.log(error);
					}
					console.log('Message %s sent: %s', info.messageId, info.response);
				});*/
			}
		}
	});

	

	
}
function writeLog(IMEI_NO, DATA, TYPE){
	var d = new Date();
	var time = dateFormat(d, "isoDateTime");
	
	var file = PORT+"-"+d.getUTCFullYear()+"-"+(d.getUTCMonth() + 1)+"-"+(d.getUTCDate())+".txt";
	if(TYPE == "SCHEDULE"){
		file = "schedule_log.txt";
	}
	
	var fs = require('fs');
	const path = require('path');
	fs.exists(path.normalize(__dirname+'../../../../logs/'+file), function(exist){
		if(exist){
			var str = time + "," + IMEI_NO + "," + DATA;
			fs.appendFile(path.normalize(__dirname+'../../../../logs/'+file), '\r\n'+str, function(err1) {
				if (err1) console.log(err1);
			});
		}else{
			fs.writeFile(path.normalize(__dirname+'../../../../logs/'+file), '--- Start Logging ---', function(err2) {
				if (err2) console.log(err2);
				console.log('NEW LOG FILE CREATED!');
			});
		}
	});
}
server.on('connection', function(sock)
{
	//console.log('SOCKET CONNECTION: ' + sock.remoteAddress +':'+ sock.remotePort);
	sockets.push(sock);
	
	//var now = new Date();
	//var newdate = dateFormat(now, "ddmmyyHHMMss");
	//sock.write("RTC,"+newdate);

	var now = new Date();
	var newdate = dateFormat(now, "ddmmyyHHMMss");
	
	var hexvalue = [0x52,0x54,0x43,0x2C];
	for(var i = 0; i<12; i+=2){
		hexvalue.push('0x'+newdate.substr(i,2));
	}
	hexvalue.push('0x0D');
	hexvalue.push('0x0A');
	
	var buff = new Buffer(hexvalue, "hex");
	//sock.write(buff);
		
	console.log('TOTAL NUMBER OF CONNECTIONS: '+sockets.length);
});
console.log('SERVER LISTENING ON ' + HOST +':'+ PORT + ' '+ST);

function Pad (str, max) {
	str = str.toString();
	return str.length < max ? Pad("0" + str, max) : str;
}
function hexval(str){
	var arr = [];
	for(var i=0; i<str.length-1; i+=2){
		arr.push(str.substr(i, 2));
	}
	var code = arr.reverse().join().replace(/,/g,'').toString();
	return parseInt(code, 16);
}


function HexToFloat(value){
	return new Buffer(value, 'hex').readFloatBE(0).toFixed(3);
}
function HexToDecimal(value){
	return parseInt(Pad(value,4), 16);
}
function HexToBin(value){
	var bytes = "";
	for(var i=0; i< value.length; i++){
		bytes += Pad(parseInt(value.substr(i, 1), 16).toString(2), 4);
	}
	return bytes;
}
function getHexToDecimal(v1,v2){
	return String(HexToDecimal(String(v2)+String(v1)));//+String(HexToDecimal(v2));
	//return String(HexToFloat(v1))+String(HexToFloat(v2));
}

function HexToDec(value){
	return parseInt(value, 16);
}