var net = require('net');
var mysql = require('mysql');
var moment = require("moment");
var httpserver = require('http').createServer();
var socketio = require('socket.io')(httpserver);
var empty = require('is-empty');

var schedule = require('node-schedule');

var HOST = '103.211.218.36';
var PORT = 32290;
var HTTP_PORT = 32291;

var dateFormat = require('dateformat');
var interval = '';
var sockets = [];
var sockets_info = [];
var connection = mysql.createConnection({
	multipleStatements: true,
	host     : 'localhost',
	user     : 'i3wd_slc',
	password : 'xmwmce4celwi',
	database : 'i3wd_scada',
	dateStrings: [
		'DATE',
		'DATETIME'
	  ]
});
var dbcols = new Array();
var tldcols = new Array();
var cname = "";
var cvalue = "";
var dt = new Date();
var ST = dt.getTime();
var dt = new Date();
var CT = dt.getTime();
var TB_DEVICE = 'master_device';
var TB_DEVICE_RECEIVED = 'device_received_data';
var TB_DEVICE_LASTDATA = 'device_last_data';
var TB_OVERVOLTAGE = 'report_overvoltage';
var TB_LOAD = 'report_overload';
var AMP_LIMIT = 1300;
var VOLTAGE_LIMIT = 28000;
var MASTER_DATA = new Object();
var DISCONNECTION_TIME_LIMIT = 30;
var CORRECTION_AMP = 2.3;

var data_check = new Object();

var IMEI_NOT_FOUND = new Object();

var ONESEC = 1000;
var ONEMIN = 60 * 1000;
var TENMIN = 10 * 60 * 1000;
var ONEHOUR = 60 * 60 * 1000;
var TWELVEHOURS = 12 * 60 * 60 * 1000;
var ONEDAY = 24 * 60 * 60 * 1000;

var DELAY = 15;

var METER_SINGLE_PHASE = 1;
var METER_THREE_PHASE = 3;


var fx = 0;
var lx = 6;

var ULB_INDEX = 0;


setTimeout(load_devices, 1000);
function load_devices(){
	var sql = "SELECT md.id, md.imei_no, dld.data_stamp, dld.update_time "+
"FROM master_device AS md "+
"LEFT JOIN device_last_data AS dld ON dld.imei_no = md.imei_no;"

	connection.query(sql, function selectCb(err, results, fields) {
		if (err) console.log(err);
		else {
			if(results.length > 0){
				for(var i=0; i<results.length; i++){
					var imei_no = results[i].imei_no;
					if(!MASTER_DATA[imei_no]){
						MASTER_DATA[imei_no] = new Object();
						MASTER_DATA[imei_no]['TIME'] = 0;
						MASTER_DATA[imei_no]['REGISTERED'] = 1;
						MASTER_DATA[imei_no]['CONNECTION'] = '';
						MASTER_DATA[imei_no]['SCHEDULE_TIME'] = moment().subtract(1, 'day').format("YYYY-MM-DD HH:mm:ss");
						MASTER_DATA[imei_no]['IMEI_NO'] = imei_no;
						MASTER_DATA[imei_no]['ON_HITS'] = 0;
						MASTER_DATA[imei_no]['OFF_HITS'] = 0;
						MASTER_DATA[imei_no]['LAST_AMP_R'] = -1;
						MASTER_DATA[imei_no]['LAST_AMP_Y'] = -1;
						MASTER_DATA[imei_no]['LAST_AMP_B'] = -1;
						MASTER_DATA[imei_no]['PREV_LOAD_DBID'] = '';
						MASTER_DATA[imei_no]['PREV_LOAD_TIME'] = '';
						MASTER_DATA[imei_no]['PREV_LOAD'] = '';
						MASTER_DATA[imei_no]['PREV_OVERVOLTAGE_TIME'] = '';
						MASTER_DATA[imei_no]['PREV_VOLTAGE_R'] = '';
						MASTER_DATA[imei_no]['PREV_VOLTAGE_Y'] = '';
						MASTER_DATA[imei_no]['PREV_VOLTAGE_B'] = '';
						MASTER_DATA[imei_no]['PREV_OVERVOLTAGE_DBID'] = '';
						MASTER_DATA[imei_no]['METER_PHASE_TYPE'] = '';
						MASTER_DATA[imei_no]['POWER_CUT'] = 0;
						MASTER_DATA[imei_no]['UPDATE_TIME'] = results[i].update_time;
					}
				}
				setTimeout(load_devices, ONEHOUR);
				//console.log("TOTAL RECORDS "+JSON.stringify(MASTER_DATA));
			}else{
				console.log("NO RECORDS");
			}
		}
	});
}


var server = net.createServer(function(sock) {
    console.log('SERVER: ' + sock.remoteAddress +':'+ sock.remotePort);
	
    
    sock.on('data', function(data) 
	{
		var dt = new Date();
		
		ST = dt.getTime();

		var d = data.toString();
		
		console.log("DATA :"+d.length+" "+d);

		fx = 0; lx = 15;
		var IMEI_NO = d.substr(fx, lx);

		fx += lx; lx = 6;
		var datestr = d.substr(fx, lx);
		var dd = datestr.substr(0, 2);
		var mm = datestr.substr(2, 2);
		var yy = datestr.substr(4, 2);
		var rec_date = yy+"-"+mm+"-"+dd;
		
		fx += lx; lx = 6;
		var timestr = d.substr(fx, lx);
		var hh = timestr.substr(0, 2);
		var mmj = timestr.substr(2, 2);
		var ss = timestr.substr(4, 2);
		var rec_time = hh+":"+mmj+":"+ss;
		
				
		writeLog(IMEI_NO, data);
		

		fx += lx; lx = 3;
		var SL_VOLTAGE = parseInt(d.substr(fx, lx));


		fx += lx; lx = 3;
		var BT_VOLTAGE = d.substr(fx, lx);

		
		if(empty(sock.imei_no)){
			sock.imei_no = IMEI_NO;
		}
		
		var skip = false;
		dt = new Date();

		if(empty(MASTER_DATA[IMEI_NO])){
			console.log(IMEI_NO+" NOT FOUND");
			if(!IMEI_NOT_FOUND[IMEI_NO]){
				IMEI_NOT_FOUND[IMEI_NO] = new Object();	
			}

			IMEI_NOT_FOUND[IMEI_NO]['TIME'] = dt.getTime();
			IMEI_NOT_FOUND[IMEI_NO]['DATA'] = d;

			return;
		}
		
		
		MASTER_DATA[IMEI_NO]['TIME'] = dt.getTime();
		MASTER_DATA[IMEI_NO]['CONNECTION'] = sock;
		
		
		var DATA = d;
		var DATA_STAMP = rec_date+" "+rec_time;
		var STATUS = "";
		var TYPE = "";
		var ACTUAL_DATA = d;
		var ACTUALDATALENGTH = d.length;
		
		
		var VOLTAGE_R,VOLTAGE_Y,VOLTAGE_B,AMP_R,AMP_Y,AMP_B;

		fx += lx; lx = 8; VOLTAGE_R = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8; VOLTAGE_Y = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8; VOLTAGE_B = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8; AMP_R = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8; AMP_Y = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8; AMP_B = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));


		console.log('IMEI NO: '+IMEI_NO);
		console.log('DATE: '+rec_date);
		console.log('TIME: '+rec_time);
		console.log('SL VOLTAGE: '+SL_VOLTAGE);
		console.log('BT VOLTAGE: '+BT_VOLTAGE);
		console.log('VOLTAGE R: '+VOLTAGE_R);
		console.log('VOLTAGE Y: '+VOLTAGE_Y);
		console.log('VOLTAGE B: '+VOLTAGE_B);
		console.log('AMP R: '+AMP_R);
		console.log('AMP Y: '+AMP_Y);
		console.log('AMP B: '+AMP_B);
		
		
		MASTER_DATA[IMEI_NO]['LAST_AMP_R'] = AMP_R;
		MASTER_DATA[IMEI_NO]['LAST_AMP_Y'] = AMP_Y;
		MASTER_DATA[IMEI_NO]['LAST_AMP_B'] = AMP_B;

		
		fx += lx; lx = 8;
		var KW = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		MASTER_DATA[IMEI_NO]['PREV_LOAD'] = KW;

		fx += lx; lx = 8;
		var PF = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));

		fx += lx; lx = 8;
		var FREQUENCY = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));

		fx += lx; lx = 8;
		var KVA = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));

		
		MASTER_DATA[IMEI_NO]['PREV_VOLTAGE_R'] = VOLTAGE_R;
		MASTER_DATA[IMEI_NO]['PREV_VOLTAGE_Y'] = VOLTAGE_Y;
		MASTER_DATA[IMEI_NO]['PREV_VOLTAGE_B'] = VOLTAGE_B;
		
		fx += lx; lx = 8;
		var KWH = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));

		fx += lx; lx = 8;
		var SPARE1 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));

		fx += lx; lx = 8;
		var SPARE2 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));


		fx += lx; lx = 8;
		var INPUT1 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8;
		var INPUT2 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8;
		var INPUT3 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8;
		var INPUT4 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8;
		var INPUT5 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));

		fx += lx; lx = 8;
		var OUTPUT1 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		fx += lx; lx = 8;
		var OUTPUT2 = getHexToDecimal(d.substr(fx, lx/2), d.substr(fx+lx/2, lx/2));
		
		var now = new Date();
		var created_at = dateFormat(now, "isoDateTime");
		

		var sql = "INSERT INTO "+TB_DEVICE_RECEIVED+" (imei_no, data_stamp, supply, battery, data, datalength, voltage_r, voltage_y, voltage_b, amp_r, amp_y, amp_b, pf, kw, kva, kwh, frequency, spare_1, spare_2, input_1, input_2, input_3, input_4, input_5, output_1, output_2, update_time) values ('"+IMEI_NO+"','"+DATA_STAMP+"','"+SL_VOLTAGE+"','"+BT_VOLTAGE+"','"+ACTUAL_DATA+"','"+ACTUALDATALENGTH+"','"+VOLTAGE_R+"','"+VOLTAGE_Y+"','"+VOLTAGE_B+"','"+AMP_R+"','"+AMP_Y+"','"+AMP_B+"','"+PF+"','"+KW+"','"+KVA+"','"+KWH+"','"+FREQUENCY+"','"+SPARE1+"','"+SPARE2+"','"+INPUT1+"','"+INPUT2+"','"+INPUT3+"','"+INPUT4+"','"+INPUT5+"','"+OUTPUT1+"','"+OUTPUT2+"', NOW())";
		//console.log(sql);
		connection.query(sql, function selectCb(err, results, fields) {
			if (err){
				console.log("ERROR DATA LENGTH "+data.length);
				console.log("ERROR IMEI_NO "+IMEI_NO);
				console.log(err);
			}else{ 
				//console.log("INSERT DATA OK");
				connection.query("UPDATE "+TB_DEVICE_LASTDATA+" SET data_stamp='"+DATA_STAMP+"', supply='"+SL_VOLTAGE+"', battery='"+BT_VOLTAGE+"', data='"+ACTUAL_DATA+"', datalength='"+ACTUALDATALENGTH+"', voltage_r='"+VOLTAGE_R+"', voltage_y='"+VOLTAGE_Y+"', voltage_b='"+VOLTAGE_B+"', amp_r='"+AMP_R+"', amp_y='"+AMP_Y+"', amp_b='"+AMP_B+"', pf='"+PF+"', kw='"+KW+"', kva='"+KVA+"', kwh='"+KWH+"', frequency='"+FREQUENCY+"', spare_1='"+SPARE1+"', spare_2='"+SPARE2+"', input_1='"+INPUT1+"', input_2='"+INPUT2+"', input_3='"+INPUT3+"', input_4='"+INPUT4+"', input_5='"+INPUT5+"', output_1='"+OUTPUT1+"', output_2='"+OUTPUT2+"', update_time=NOW() WHERE imei_no = '"+IMEI_NO+"'",
				function selectCb(err, results, fields) {
					if (err) {
						console.log(err);
					}else{ 
						//console.log("INSERT TRANS LAST DATA OK");
					}
				});
			}
		});   
    });
    sock.on('close', function(data) 
	{
        console.log('SOCKET CLOSING ');
		var idx = sockets.indexOf(this);
		if (idx != -1) 
		{
			sockets.splice(idx,1);
		}
		//console.log('TOTAL NUMBER OF CONNECTIONS: '+sockets.length);
    });
	sock.on('end', function() {
        console.log('SOCKET END ');
		var idx = sockets.indexOf(this);
		if (idx != -1) {
			sockets.splice(idx,1);
		}
		//console.log('TOTAL NUMBER OF CONNECTIONS: '+sockets.length);
    });
	sock.on('error', function(){
		console.log('ERROR IN SOCKET CONNECTION');
		var idx = sockets.indexOf(this);
		if (idx != -1) {
			sockets.splice(idx,1);
		}
		//console.log('TOTAL NUMBER OF CONNECTIONS: '+sockets.length);
	});
	sock.setKeepAlive(true);
}).on('error', function(err) {
	console.log('ERROR '+ err);
});
server.listen(PORT, HOST);
function writeLog(IMEI_NO, DATA, TYPE){
	var d = new Date();
	var time = dateFormat(d, "isoDateTime");
	
	var file = PORT+"-"+d.getUTCFullYear()+"-"+(d.getUTCMonth() + 1)+"-"+(d.getUTCDate())+".txt";
	if(TYPE == "SCHEDULE"){
		file = "schedule_log.txt";
	}
	
	var fs = require('fs');
	fs.exists('logs/'+file, function(exist){
		if(exist){
			var str = time + "," + IMEI_NO + "," + DATA;
			fs.appendFile('logs/'+file, '\r\n'+str, function(err1) {
				if (err1) console.log(err1);
			});
		}else{
			fs.writeFile('logs/'+file, '--- Start Logging ---', function(err2) {
				if (err2) console.log(err2);
				console.log('NEW LOG FILE CREATED!');
			});
		}
	});
}
server.on('connection', function(sock)
{
	//console.log('SOCKET CONNECTION: ' + sock.remoteAddress +':'+ sock.remotePort);
	sockets.push(sock);
	
	var now = new Date();
	var newdate = dateFormat(now, "ddmmyyHHMMss");
	sock.write("RTC,"+newdate);
		
	//console.log('TOTAL NUMBER OF CONNECTIONS: '+sockets.length);
});
console.log('SERVER LISTENING ON ' + HOST +':'+ PORT + ' '+ST);

function Pad (str, max) {
	str = str.toString();
	return str.length < max ? Pad("0" + str, max) : str;
}
function hexval(str){
	var arr = [];
	for(var i=0; i<str.length-1; i+=2){
		arr.push(str.substr(i, 2));
	}
	var code = arr.reverse().join().replace(/,/g,'').toString();
	return parseInt(code, 16);
}


function HexToFloat(value){
	return new Buffer(value, 'hex').readFloatBE(0).toFixed(3);
}
function HexToDecimal(value){
	return parseInt(Pad(value,4), 16);
}
function HexToBin(value){
	var bytes = "";
	for(var i=0; i< value.length; i++){
		bytes += Pad(parseInt(value.substr(i, 1), 16).toString(2), 4);
	}
	return bytes;
}
function getHexToDecimal(v1,v2){
	return String(HexToDecimal(String(v2)+String(v1)));//+String(HexToDecimal(v2));
	//return String(HexToFloat(v1))+String(HexToFloat(v2));
}

