var express = require("express");
var router = express.Router();
var conn = require("./db");
var md5 = require("md5");
var empty = require("is-empty");
var moment = require("moment");
var url = require("url");
var socketio = require("socket.io")();

/* var server = require("http").createServer(express);
var io = require("socket.io")(server); */

const fileUpload = require("express-fileupload");
router.use(
  fileUpload({
    useTempFiles: true,
    tempFileDir: "/tmp/",
  })
);

var mysql = require("mysql");
var pool = mysql.createPool({
  connectionLimit: 50,
  host: "localhost",
  user: "i3wd_slc",
  password: "xmwmce4celwi",
  database: "i3wd_slc",
  multipleStatements: true,
  dateStrings: ["DATE", "DATETIME"],
});

var pool_login = mysql.createPool({
  connectionLimit: 50,
  host: "localhost",
  user: "i3wd_slc",
  password: "xmwmce4celwi",
  database: "i3wd_login",
  multipleStatements: true,
  dateStrings: ["DATE", "DATETIME"],
});

var pool_up = mysql.createPool({
  connectionLimit: 50,
  host: "localhost",
  user: "ccmsup_usr",
  password: "az7gurl0nmns",
  database: "ccmsup_db",
  multipleStatements: true,
  dateStrings: ["DATE", "DATETIME"],
});
var pool_rj = mysql.createPool({
  connectionLimit: 50,
  host: "localhost",
  user: "ccmsrj_usr",
  password: "883kpy86va7f",
  database: "ccmsrj_db",
  multipleStatements: true,
  dateStrings: ["DATE", "DATETIME"],
});
var pool_dl = mysql.createPool({
  connectionLimit: 50,
  host: "localhost",
  user: "ccmsdl_usr",
  password: "19o13rw00y62",
  database: "ccmsdl_db",
  multipleStatements: true,
  dateStrings: ["DATE", "DATETIME"],
});

// Yash Changes for New State Setup Streetlight
var pool_jhansi = mysql.createPool({
  connectionLimit: 50,
  host: "13.200.81.42",
  user: "admin",
  password: "admin@123",
  database: "jhansi_db",
  multipleStatements: true,
  dateStrings: ["DATE", "DATETIME"],
});
// Yash Changes for New State Setup Streetlight

var import_data = [];
var import_result = [];
var import_index = 0;

var POOLDB = {
  "gorakhpur.ccms.live": pool_jhansi, 
  "216.10.243.92": pool_jhansi, 
  IN_MH: pool,
  IN_UP: pool_up,
  IN_RJ: pool_rj,
  IN_DL: pool_up,
  IN_JHANSI: pool_jhansi, // Yash Changes for New State Setup Streetlight
};

var DASHBOARD = {
  "216.10.251.190": "/state-dashboard/in-mh",
  "103.211.218.36": "/state-dashboard/in-up",
  "216.10.245.169": "/state-dashboard/in-rj",
  "119.18.52.29": "/state-dashboard/in-dl",
  "mh.ccms.live": "/state-dashboard/in-mh",
  "103.211.219.21": "/state-dashboard/in-jhansi", // Yash Changes for New State Setup Streetlight
  "localhost": "/state-dashboard/in-gorakhpur",
  "gorakhpur.ccms.live": "/state-dashboard/in-gorakhpur",
  "216.10.243.92": "/state-dashboard/in-gorakhpur",
};
var STATEIP = {
  IN_MH: "216.10.251.190",
  IN_UP: "103.211.218.36",
  IN_RJ: "216.10.245.169",
  IN_DL: "119.18.52.29",
  IN_JHANSI: "103.211.219.21", // Yash Changes for New State Setup Streetlight
};

var IN_MH = "216.10.251.190";
var IN_UP = "103.211.218.36";
var IN_RJ = "216.10.245.169";
var IN_DL = "119.18.52.29";
var IN_JHANSI = "103.211.219.21"; // Yash Changes for New State Setup Streetlight

/* GET home page. */
router.get("/", function (req, res, next) {
  console.log(req.hostname);
  res.render("index", { title: "Express Yash" });
});

router.get("/dev", function (req, res, next) {
  var sql = "SELECT count(id) as total FROM master_device";
  POOLDB[req.hostname].getConnection(function (err, connection) {
    if (err) console.log(err);

    connection.query(sql, function (error, result) {
      connection.release();

      if (error) {
        console.log(error);
        var mess = { error: 1, message: "Issue!", result: 0 };
        res.send(JSON.stringify(mess));
      } else {
        if (result.length > 0) {
          var mess = { error: 1, message: "ok! " + result[0]["total"], result: 0 };
          res.send(JSON.stringify(mess));
        } else {
          var mess = { error: 2, message: "failed!", result: 0 };
          res.send(JSON.stringify(mess));
        }
      }
    });
  });
});

router.get("/", function (req, res, next) {
  res.render("index", { title: "Express API Yash" });
});


function saveUserActivity(req, res, next) {
  console.log("------ SAVE USER ACTIVITY ------ " + req.user_id + " " + req.url);
  if (!req.user_id) {
    next();
  } else {
    POOLDB[req.hostname].getConnection(function (err, connection) {
      if (err) {
        console.log(err);
        next();
      } else {
        var insertq = {
          user_id: req.user_id,
          url: req.url,
          data: JSON.stringify(req.body),
        };
        //	console.log("INSERTING DATA "+JSON.stringify(req.body));
        var sql = "INSERT INTO user_logs SET ? , insert_time = NOW()";
        var q = connection.query(sql, insertq, function (error, result) {
          connection.release();

          //console.log(q.sql);

          next();
        });
      }
    });
  }
}

function checkAuth(req, res, next) {
  var accesskey = req.body.accesskey;

  if (empty(accesskey)) {
    console.log("***************** Unauthorised Access! ***************");
    var mess = { error: 1, message: "Unauthorised Access!", result: 0 };
    res.send(JSON.stringify(mess));
  } else {
    //var accesskey = req.body.accesskey;

    console.log("CHK AUTH " + req.hostname + " " + accesskey);

    pool_jhansi.getConnection(function (err, connection) {
      if (err) console.log(err);

      var sql =
        'SELECT ap.user_id, u.permissions from access_permission ap LEFT JOIN users u ON ap.user_id=u.id WHERE ap.access_key = "' +
        accesskey +
        '" AND ap.is_valid=1;';
      connection.query(sql, function (error, result) {
        if (error) {
          console.log(error);
          connection.release();
          var mess = { error: 1, message: "Database issue. please login again!", result: 0 };
          res.send(JSON.stringify(mess));
        } else {
          if (result.length > 0) {
            console.log("------x------ LOGIN SUCCESSFULLY ------x------");
            req.user_id = result[0].user_id;
            req.permissions = JSON.parse(result[0].permissions);
            connection.release();

            next();
          } else {
            connection.release();
            console.log("!!!!!!!!!!! SECURITY ISSUE !!!!!!!!!!!!");
            var mess = { error: 2, message: "Session Timeout. For security reason, please login again!", result: 0 };
            res.send(JSON.stringify(mess));
          }
        }
      });
    });
  }
}




/************************************************* Light LED METHODS END *****************************************/

router.post("/lights", checkAuth, function (req, res, next) {
  var ulbareacode = req.body.ulbareacode;

  if (ulbareacode != "") {
    var perms 		= req.permissions;
    var roleId 		=  req.body.role;
    var user_id 	=  req.user_id;
	var datefrom 	= req.body.datefrom;
	var dateto 		= req.body.dateto;
   
	
	/* var onlySelfdata = '';
	if(roleId==15){
		onlySelfdata = " AND c.supervisor_id='"+user_id+"'";
	} */

    /* var sql =
      "SELECT c.*,us.username supervisor_name, mz.title ulb_title, ml.location location_title,ml.ward_id,w.title ward_name,w.areacode ward_code FROM complaints c LEFT JOIN master_zone mz ON mz.id=c.ulb LEFT JOIN master_location ml ON ml.feeder_pillar_no = c.location left join users us on(c.supervisor_id=us.id) left join master_ward w on(ml.ward_id=w.id) WHERE ";
	  if(datefrom!='' || dateto!=''){	
			sql+=" c.insert_time >= DATE_FORMAT('" +datefrom + " 00:00:00', '%y-%m-%d %H:%i:%s') AND c.insert_time <= DATE_FORMAT('" + dateto + " 23:59:59', '%y-%m-%d %H:%i:%s')";
	  }else{  
			sql+=" c.insert_time >= CURRENT_DATE ";
	  }
	  
	  if(roleId==15){
		  sql+=" AND c.supervisor_id='"+user_id+"'"; 
	  }
	  sql+=" ORDER BY id DESC;"; */
	  
	  
	  var sql =
      "SELECT ls.id,ls.feeder_pillar_no fp_no,ls.location,ls.led_fittings,ls.led_electrician,ls.led_warranty,ls.led_brand,ls.led_vendor,ls.vendor,ls.update_time FROM inv_lights as ls ";
	  sql+=" ORDER BY ls.update_time DESC;";
	  
	  
	   sql+="SELECT id,name as brand_name FROM inv_light_brands;";
	   sql+="SELECT id,name as vendor_name FROM inv_vendors where status=1;";

     sql+="SELECT id as ele_id, username,email FROM `users` WHERE role=17 AND status=1;";
	  
	  
     //console.log("sql sql:::::::",sql);
	  
	   /*  if (!empty(perms.ulb_perm)) {
		  sql =
			"SELECT c.*,us.username supervisor_name, ml.location location_title FROM complaints c LEFT JOIN master_zone mz ON mz.id=c.ulb LEFT JOIN master_location ml ON ml.feeder_pillar_no = c.location left join users us on(c.supervisor_id=us.id) WHERE c.state='" + perms.state_perm +"' "+onlySelfdata+"  AND mz.areacode='" +
			perms.ulb_perm +
			"' ORDER BY c.id DESC;";
		} else if (!empty(perms.state_perm)) {
		  sql = 'SELECT * FROM complaints WHERE state="' + perms.state_perm + '" and (insert_time > DATE_SUB(now(), INTERVAL 1 DAY)) ORDER BY id DESC;';
		} */
		//sql += "SELECT * FROM master_zone;";
		//sql += "SELECT * FROM master_ward where status=1;";
		//console.log(sql);

		POOLDB[req.hostname].getConnection(function (err, connection) {
		  if (err) console.log(err);

		  connection.query(sql, function (error, result) {
			connection.release();

			if (error) {
			  console.log(error);

			  var mess = { error: 1, message: "Error!", result: 0 };
			  res.send(JSON.stringify(mess));
			} else {
			  var o = {
				 
				complaints: result[0],
				led_brands: result[1],
				led_vendors: result[2],
        electrician: result[3],
				zones: [],
				wards_list: [],
			  };
			  var mess = { error: 0, message: "Lights records!", result: o };
			  res.send(JSON.stringify(mess));
			}
		  });
		});

   
	} else {
    var mess = { error: 1, message: "Failed!", result: [] };
    res.send(JSON.stringify(mess));
  }
});

router.post("/light-update", checkAuth, saveUserActivity, function (req, res, next) {
  var updatedata = req.body.data;
  console.log('updatedata',JSON.stringify(updatedata));
  
 /*  var 
  
   
  return false;
   */
  var user_id = req.user_id;
	console.log('UserId:',user_id);
  if (user_id != "") {
   // var state_code = updatedata.state.split("-")[1];

	var warantyInsertTime = moment().format('YYYY-MM-DD HH:MM:SS');
    var updateq = {      	 
      insert_time: warantyInsertTime
    };
	
	
	if(updatedata.led_fittings!=''){
	 updateq.led_fittings = JSON.stringify(updatedata.led_fittings);
	}
	if(updatedata.led_warranty!=''){
	 updateq.led_warranty = JSON.stringify(updatedata.led_warranty);
	}
	if(updatedata.led_brand!=''){
	 updateq.led_brand = JSON.stringify(updatedata.led_brand);
	}
	if(updatedata.led_vendors!=''){
	 updateq.led_vendor = JSON.stringify(updatedata.led_vendors);
	}
  if(updatedata.led_electrician!=='' && updatedata.led_electrician!==null){
    updateq.led_electrician = JSON.stringify(updatedata.led_electrician);
   }
	
	
	
   /*  if (!empty(updatedata.mobile)) {
      updateq.mobile = updatedata.mobile;
    } */
	

    POOLDB[req.hostname].getConnection(function (err, connection) {
      if (err) console.log(err);

     // var sql = 'INSERT INTO inv_lights_data SET ? , update_time = NOW() WHERE id="' + updatedata.id + '"';
      var sql = 'INSERT INTO inv_lights_data SET feeder_pillar_no="'+updatedata.fp_no+'", ? , update_time = NOW();';
	
	  
	  
		console.log('updateq:',updateq);
		console.log('DEVELOPE:',sql);
      connection.query(sql, updateq, function (error, result) {
        //connection.release();

        if (error) {
          var mess = { error: 1, message: "Error!", result: 0 };
          res.send(JSON.stringify(mess));
        } else {
			
				 var sqlU= 'UPDATE inv_lights SET ? , update_time = NOW() WHERE id="'+updatedata.id+'";';
				connection.query(sqlU, updateq, function (error, result) {
				connection.release();
					if (error) {
						var mess = { error: 1, message: "Error!", result: 0 };
						res.send(JSON.stringify(mess));
					}else {
						var mess = { error: 0, message: "LED Updated Successfully!", result: 1 };
						res.send(JSON.stringify(mess));
					}
					
					
				});
         
        }
      });
    });
  } else {
    var mess = { error: 1, message: "Failed!", result: 0 };
    res.send(JSON.stringify(mess));
  }
});

router.post("/led-details", checkAuth, function (req, res, next) {
  var fp_no = req.body.fp_no;
  if (fp_no != "") {
    POOLDB[req.hostname].getConnection(function (err, connection) {
      if (err) console.log(err);

      //var sql ="SELECT * FROM inv_lights_data WHERE feeder_pillar_no=? ORDER BY id DESC ;";
	  
	   var sql =
      "SELECT ls.id,ls.feeder_pillar_no fp_no,ml.location,ls.led_fittings,ls.led_warranty,ls.led_brand,ls.led_vendor,ls.vendor,ls.update_time FROM inv_lights_data as ls inner join master_location ml on(ml.feeder_pillar_no = ls.feeder_pillar_no) where ls.feeder_pillar_no=? ";
	  sql+=" ORDER BY ls.update_time DESC;";
	  
	  
	   sql+="SELECT id,name as brand_name FROM inv_light_brands;";
	   sql+="SELECT id,name as vendor_name FROM inv_vendors where status=1;";
	  
	  
	  
	  
      connection.query(sql, fp_no, function (error, result) {
        connection.release();
        if (error) {
          console.log(error);
        }
        var o = {
          records: result[0],
		  led_brands: result[1],
		  led_vendors: result[2],
          location: [],
          device:[],
        };

        var mess = { error: 0, message: "Led records!", result: o };
        res.send(JSON.stringify(mess));
      });
    });
  } else {
    var mess = { error: 1, message: "Failed!", result: [] };
    res.send(JSON.stringify(mess));
  }
});


router.post("/led-report", checkAuth, function (req, res, next) {
  var datefrom = req.body.datefrom;
  var dateto = req.body.dateto;
  var ledvalue = req.body.ledvalue; 
  if (datefrom != "" && dateto !="") {
    POOLDB[req.hostname].getConnection(function (err, connection) {
      if (err) console.log(err);

      //var sql ="SELECT * FROM inv_lights_data WHERE feeder_pillar_no=? ORDER BY id DESC ;";
	  
	   var sql =
      "SELECT ls.id,ls.feeder_pillar_no fp_no,ml.location,ls.led_fittings,ls.led_warranty,ls.led_brand,ls.led_vendor,ls.vendor,ls.led_electrician,ls.insert_time,ls.update_time FROM inv_lights_data as ls inner join master_location ml on(ml.feeder_pillar_no = ls.feeder_pillar_no) where ls.feeder_pillar_no IS NOT NULL ";
	  
	  sql+=" AND (ls.update_time BETWEEN '"+datefrom + " 00:00:00' AND '" + dateto + " 23:59:59') ";
	  if(ledvalue!=0){
		  var ledFilter = '$.'+ledvalue;
		sql+=" AND JSON_EXTRACT(ls.led_fittings, '"+ledFilter+"') > 0  ";
	  }
	  
	  sql+=" ORDER BY ls.update_time DESC;";
	  
	  
	   sql+="SELECT id,name as brand_name FROM inv_light_brands;";
	   sql+="SELECT id,name as vendor_name FROM inv_vendors where status=1;";
     sql+="SELECT id as ele_id, username,email FROM `users` WHERE role=17 AND status=1;";

	  
	 console.log('sql  sql',sql);
	  
	  
      connection.query(sql, function (error, result) {
        connection.release();
        if (error) {
          console.log(error);
        }
        var o = {
          records: result[0],
          led_brands: result[1],
          led_vendors: result[2],
          electrician: result[3],
          location: [],
          device:[],
        };

        var mess = { error: 0, message: "Led records!", result: o };
        res.send(JSON.stringify(mess));
      });
    });
  } else {
    var mess = { error: 1, message: "Failed!", result: [] };
    res.send(JSON.stringify(mess));
  }
});






router.post("/ulb-locations", checkAuth, function (req, res, next) {
  var ulb_id = 1; //req.body.ulb_id;
  var user_id = req.user_id;

  if (ulb_id > 0) {
    POOLDB[req.hostname].getConnection(function (err, connection) {
      if (err) console.log(err);

		var moreattribut=''; 
		//if (req.hostname == "103.211.219.21") {
			moreattribut= 'ml.imei_no,md.supervisor_id,';
		//}

      var sql = "SELECT ml.feeder_pillar_no fpno, "+moreattribut+" ml.location FROM master_location as ml";
	  //if (req.hostname == "103.211.219.21") {
		sql+=" left join master_device as md on(ml.imei_no=md.imei_no)";
	 // }
	 // sql+=" WHERE ml.ulb_id='" + ulb_id + "';";

      connection.query(sql, function (error, result) {
        connection.release();

        if (error) {
          var mess = { error: 1, message: "Error!", result: 0 };
          res.send(JSON.stringify(mess));
        } else {
          var o = {
            locations: result,
          };
          var mess = { error: 0, message: "Get All Location Successfully!", result: o };
          res.send(JSON.stringify(mess));
        }
      });
    });
  } else {
    var mess = { error: 1, message: "Failed!", result: 0 };
    res.send(JSON.stringify(mess));
  }
}); 

router.post("/getSupervisor-list", checkAuth, function (req, res, next) {

	console.log('getSupervisor-list');
  
    POOLDB[req.hostname].getConnection(function (err, connection) {
      if (err) console.log(err);

	
      var sql = "SELECT us.id supervisor_id,us.email,us.username FROM users as us WHERE us.role='15' and us.status=1 order by us.username ASC";
	 
      connection.query(sql, function (error, result) {
        connection.release();

        if (error) {
          var mess = { error: 1, message: "Error!", result: 0 };
          res.send(JSON.stringify(mess));
        } else {
          var o = {
            supervisor: result,
          };
          var mess = { error: 0, message: "Get All Supervisor Successfully!", result: o };
          res.send(JSON.stringify(mess));
        }
      });
    });
 
});


/************************************************* LED METHODS END *****************************************/















function a() {
  return 10;
}
function b() {
  return 20;
}


function reportError(req, id, callback) {
  var updateq = {
    status: 2,
  };
  var sql = 'UPDATE daily_reports SET ? WHERE id="' + id + '"';

  POOLDB[req.hostname].getConnection(function (err, connection) {
    if (err) {
      console.log(err);
      callback(err);
    } else {
      connection.query(sql, updateq, function (error, result) {
        connection.release();
        if (error) {
          callback(error);
        } else {
          callback(result);
        }
      });
    }
  });
}
function generateReports(data, header, filename, callback) {
  const fastcsv = require("fast-csv");
  const path = require("path");
  const fs = require("fs");

  var csvpath = path.join(__dirname, "../public/exports/" + filename + ".csv");
  var pdfpath = path.join(__dirname, "../public/exports/" + filename + ".pdf");
  const ws = fs.createWriteStream(csvpath);

  const jsonData = JSON.parse(JSON.stringify(data));

  //console.log(jsonData);

  var o = {};
  var i = 0;
  for (const [key, value] of Object.entries(jsonData[0])) {
    o[key] = header[i];
    i++;
  }
  jsonData.unshift(o);

  fastcsv
    .write(jsonData, { headers: false })
    .on("finish", function () {
      //console.log("Write to "+filename+".csv successfully!");

      var fonts = {
        Roboto: {
          normal: "fonts/Roboto-Regular.ttf",
          bold: "fonts/Roboto-Medium.ttf",
          italics: "fonts/Roboto-Italic.ttf",
          bolditalics: "fonts/Roboto-MediumItalic.ttf",
        },
      };

      var PdfPrinter = require("pdfmake");
      var printer = new PdfPrinter(fonts);

      var pdfdata = [];

      jsonData.forEach((line) => {
        pdfdata.push(Object.values(line));
      });
      //console.log(pdfdata);

      var docDefinition = {
        pageOrientation: "landscape",
        content: [
          {
            style: "tableExample",
            table: {
              headerRows: 1,
              body: pdfdata,
            },
          },
        ],
        styles: {
          tableExample: {
            fontSize: 8,
            margin: [0, 5, 0, 15],
          },
        },
      };
      var pdfDoc = printer.createPdfKitDocument(docDefinition);
      pdfDoc.pipe(fs.createWriteStream(pdfpath));
      pdfDoc.end();

      callback(1);
    })
    .pipe(ws);
}

	function generatePdf(sourcecsv, newcsvpath, targetpdf, callback) {
	  var fs = require("fs");
	  fs.copyFile(sourcecsv, newcsvpath, (err) => {
		if (err) {
		  console.log(err);
		  callback(0);
		} else {
		  var fonts = {
			Roboto: {
			  normal: "fonts/Roboto-Regular.ttf",
			  bold: "fonts/Roboto-Medium.ttf",
			  italics: "fonts/Roboto-Italic.ttf",
			  bolditalics: "fonts/Roboto-MediumItalic.ttf",
			},
		  };

		  var PdfPrinter = require("pdfmake");
		  var printer = new PdfPrinter(fonts);
		  var fs = require("fs");

		  var pdfdata = [];

		  const data = fs.readFileSync(newcsvpath, "UTF-8");
		  const lines = data.split(/\r?\n/);
		  lines.forEach((line) => {
			if (line.split(",").length > 1) {
			  pdfdata.push(line.split(","));
			}
		  });

		  var docDefinition = {
			pageOrientation: "landscape",
			content: [
			  {
				style: "tableExample",
				table: {
				  headerRows: 1,
				  body: pdfdata,
				},
			  },
			],
			styles: {
			  tableExample: {
				fontSize: 8,
				margin: [0, 5, 0, 15],
			  },
			},
		  };
		  var pdfDoc = printer.createPdfKitDocument(docDefinition);
		  pdfDoc.pipe(fs.createWriteStream(targetpdf));
		  pdfDoc.end();

		  callback(1);
		}
	  });
	}



// made for inser csv data    insert-csv-data
	router.post("/insert-csv-data", checkAuth, function (req, res, next) {
	  //var insertdata = req.body.data;
	  var csvDatas = req.body.csvkey;	 
	  if(csvDatas != undefined && csvDatas != "") {
			var dataInsert =new Array();
			var dataErrore = '';
			csvDatas.forEach(function (item) {					
				var imei_no 	= String(item.imei_no).length==15?item.imei_no:'';
				var on_time 	= item.ontime;
				var off_time 	= item.offtime;
				if(!empty(imei_no) && !empty(on_time) && !empty(off_time)){
				var exErry		= {'imei_no':imei_no,'on_time':on_time,'off_time':off_time};
					dataInsert.push(exErry);
				}else{
					//var dError ={item.imei_no};
					dataErrore+=item.imei_no+',';
				}
			
			}); 
			
			
				
				if(dataInsert.length>0) {
						var i=1;					
						dataInsert.forEach(function (itemIn) {
							
							var uQuery = "update master_device set on_time='"+itemIn.on_time+"',off_time='"+itemIn.off_time+"' where imei_no='"+itemIn.imei_no+"'";
							//console.log("Query:"+uQuery);
							pool_jhansi.query(uQuery, function (error, result) {
							//connection.release();
							if (error) {
							  console.log("asdasdasdasdasd:"+error);
							  dataErrore+=itemIn.imei_no+',';
							}
							
							if(dataInsert.length<i){	
								var msg = "Schedule Set Successfully!"
								if(!empty(dataErrore)){
									msg+="But this CCMS has not updated: "+dataErrore;
								}
								var mess = { error: 0, message: msg, result: [] };
								res.send(JSON.stringify(mess));
							}
						  });
							i++;
						});
				  
				} else {
				  var mess = { error: 1, message: "IMEI Number Not exit!", result: [] };
				  res.send(JSON.stringify(mess));
				}
			  
				
			
		}else{
			var mess = { error: 1, message: "CSV Empty file!", result: 0 };
			res.send(JSON.stringify(mess));
		}
	  
	});

  router.post("/vandor-record", checkAuth, function (req, res, next) {
    var sql = "SELECT * FROM inv_vendors";
  
    POOLDB[req.hostname].getConnection(function (err, connection) {
      if (err) {
        console.log(err);
        var mess = { error: 1, message: "Database connection error!", result: [] };
        res.send(JSON.stringify(mess));
      } else {
        connection.query(sql, function (error, result) {
          connection.release();
  
          var mess = { error: 0, message: "Ward records!", result: result };
          res.send(JSON.stringify(mess));
        });
      }
    });
  });

// **********************Add Vandor START**************************

// *********************Add Vandor END*****************************



  router.post("/vandor-insert", checkAuth, function (req, res, next) {
    
    var insertdata = req.body.data;
    console.log('FZ---------',insertdata);

    if (insertdata) {
      var insertq = {
        name: insertdata.name,
        company: insertdata.company,
        phone_no: insertdata.phone_no,
        address: insertdata.address,
        status: insertdata.status
      };

      //console.log("insertq insertq ",insertq);
  
      var sql = "INSERT INTO inv_vendors SET ? , insert_date = NOW(), update_date = NOW();";

      console.log("SQL ===========================",req.hostname)
  
      POOLDB[req.hostname].getConnection(function (err, connection) {
        if (err) {
          console.log(err);
          var mess = { error: 1, message: "Database connection error!", result: [] };
          res.send(JSON.stringify(mess));
        } else {
          connection.query(sql, insertq, function (error, result) {
            connection.release();
  
            if (error) {
              var mess = { error: 1, message: "Connect Error!", result: 0 };
              res.send(JSON.stringify(mess));
            } else {
              var mess = { error: 0, message: "vandor Added Successfully!", result: 1 };
              res.send(JSON.stringify(mess));
            }
          });
        }
      });
    } else {
      var mess = { error: 1, message: "Failed to add vandor!", result: 0 };
      res.send(JSON.stringify(mess));
    }
  });

  router.post("/vandor-update", checkAuth, function (req, res, next) {
    
    var insertdata = req.body.data;
    console.log('FZ-----------------------',insertdata);

    if(insertdata.id !=='' && insertdata.id !==null)
    {
      if (insertdata) {
        var updateq = {
          name: insertdata.name,
          company: insertdata.company,
          phone_no: insertdata.phone_no,
          address: insertdata.address,
          status: insertdata.status
        };

        //console.log("updateq updateq::",updateq);
    
        var sql = 'UPDATE inv_vendors SET ? , update_date = NOW() WHERE id="' + insertdata.id + '";';

        //console.log("SQL ===========================",req.hostname);
        //console.log("SQL ===========================",sql);
    
        POOLDB[req.hostname].getConnection(function (err, connection) {
          if (err) {
            console.log(err);
            var mess = { error: 1, message: "Database connection error!", result: [] };
            res.send(JSON.stringify(mess));
          } else {
            connection.query(sql, updateq, function (error, result) {
              connection.release();
    
              if (error) {
                var mess = { error: 1, message: "Connect Error!", result: 0 };
                res.send(JSON.stringify(mess));
              } else {
                var mess = { error: 0, message: "Vandor Updated Successfully!", result: 1 };
                res.send(JSON.stringify(mess));
              }
            });
          }
        });
      } else {
        var mess = { error: 1, message: "Failed to add vandor!", result: 0 };
        res.send(JSON.stringify(mess));
      }
    }
    else {
      var mess = { error: 1, message: "Vandor id can't be empty!", result: 0 };
      res.send(JSON.stringify(mess));
    }
  });

  router.post("/vandor-delete", checkAuth, function (req, res, next) {
    
    var deletevandor = req.body;
    console.log('FZ---------',deletevandor);

    if(deletevandor.id !=='' && deletevandor.id !==null)
    {
        var sql = "DELETE FROM inv_vendors WHERE id='" + deletevandor.deleteid + "';"

        //console.log("SQL ===========================",req.hostname);
        console.log("SQL ===========================",sql);
    
        POOLDB[req.hostname].getConnection(function (err, connection) {
          if (err) {
            console.log(err);
            var mess = { error: 1, message: "Database connection error!", result: [] };
            res.send(JSON.stringify(mess));
          } else {
            connection.query(sql, function (error, result) {
              connection.release();
    
              if (error) {
                var mess = { error: 1, message: "Connect Error!", result: 0 };
                res.send(JSON.stringify(mess));
              } else {
                var mess = { error: 0, message: "Vandor Deleted Successfully!", result: 1 };
                res.send(JSON.stringify(mess));
              }
            });
          }
        });
    }
    else {
      var mess = { error: 1, message: "Vandor id can't be empty!", result: 0 };
      res.send(JSON.stringify(mess));
    }
  });

  
  
  

module.exports = router;
